// mirc_dllhell.h
// Mirc Dll Support Code


//---------------------------------------------------------------------------
// To avoid multiple header instantiations
#ifndef _mirc_dllshellh
#define _mirc_dllshellh
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Compiler directive for dlls
#define WIN32_LEAN_AND_MEAN
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <windows.h>
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// Global variables
extern HINSTANCE DllWindow_hinstance;
extern LPVOID mircdllheap;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Global typedef
typedef struct {
	DWORD mVersion;
	HWND mHwnd;
	BOOL mKeep;
} LOADINFO;
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Forward declarations for helper functions provided by this .cpp file
int _atolp(char* p);
char* _getword(char*& p);
char* _getlcword(char*& p);
char *_mystrchr(char *p,char c);
#ifndef lopen
 #define lopen _lopen
 #endif
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Forward declarations for functions you MUST implement in your code
// Note: this is somewhat unusual, in that the forward declaration here is
//  for functions that are implemented not in mirc_dllshell.cpp, but in your
//  derived function file.
extern const char *get_mircDllInfo();
extern const char *get_mircDllVersion();
extern bool do_mircDllLoad(LOADINFO* loadinfo);
extern int do_mircDllUnLoad(int mode);
extern void do_DllStart();
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// replacement new and delete, so avoid having to call c lang default lib
LPVOID __cdecl operator new(size_t n);
void __cdecl operator delete(LPVOID p);
int __cdecl _purecall();
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// #define DLLLINFO - you should replace this in your code
#define FUNCPARMS    HWND mWnd, HWND aWnd, char* data, char* parms, BOOL show, BOOL nopause
#define DllExport    extern "C" __declspec(dllexport)
#define MircFunc     extern "C" __declspec(dllexport) int __stdcall
//---------------------------------------------------------------------------
#define dllret(parms) { wsprintf(data,"%s",parms); return 3; }
#define dllret2(params1,params2) { wsprintf(data,"%s %s",params1,params2); return 3; }
#define mylowercase(p); { if (*p>'A' && *p<'Z') *p=*p+32; }
//---------------------------------------------------------------------------







//---------------------------------------------------------------------------
#endif