// mircryption.cpp
// 12/19/01 - Dark Raichu


//---------------------------------------------------------------------------
#include <string.h>
#include <stdio.h>
#include <windows.h>
#include "mircryption.h"
#include "mircryption_resource.h"
#include "blowfish.h"
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Global variables
char KEYFILENAME[255] = "MircryptionKeys.txt";
char masterpassphrase[MAXKEYSIZE];
char mastercheckword[MAXKEYSIZE];
bool passphrasesunlockedflag=false;
Keypair *keypairs=NULL;
int keys=0;
bool keyfilebackedup=false;
int badtries=0;
int loadcalls=0;
bool dialogup=false;
// for sending irc window text
HWND ircMapWindow=0;
HANDLE ircMapHandle=0;
LPSTR ircMapData=NULL;
char *ircMapTempTextp=NULL;
char ircMapChannelname[255];
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// mircDll support functions, called from mirc_dllshell.cpp

// just return a string of info about the dll
const char *get_mircDllInfo() {return MIRCDLL_INFO;}
const char *get_mircDllVersion() {return MIRCDLL_VERSION;}

// when dll loads for first time
void do_DllStart()
{
	// initialize
	//	MessageBox(0, "DLL start", "Mircryption Message", 0);
}


// load the dll
bool do_mircDllLoad(LOADINFO* loadinfo)
{

	// This function is called when the dll is first accessed - here you reserve any global stuff.
	// Return true if you want to stay loaded on return or false is you can be unloaded immediately.

	// there may be a bug, or its a multithreading thing, that can cause 2 calls to load. we ignore all but first
	++loadcalls;
	if (loadcalls>1)
		{
		// load any existing keys (but keep them in encrypted state for now), and clear passphrases
		// MessageBox(0, "MULTIPLE DLL LOAD!", "Mircryption Message", 0);
		return true;
		//		return false;
		}

	//	keypairs=NULL;
	//	keys=0;
	//	keyfilebackedup=false;
	//	badtries=0;

	if (passphrasesunlockedflag==false)
		load_keys();
	// we want to stay loaded so we return true
	return true;
}


// unload the dll
int do_mircDllUnLoad(int mode)
	{
	// This function is called when mirc requests that the dll unload.
	// However, sometimes it is ok to turn down this request.
	// if m==1 then the request is a polite, perfunctary request after 10 minutes of inactivity
	//    which you may want to turn down if you need to preserve memory objects.
	// if m!=1 then this is a forcefull request to terminate, and you should terminate.
	// RETURN 0 if you refuse to terminate, or 1 if you have freed up your memory and are willing to unload

	if (mode==1)
		{
		// this is a polite 10min inactive call to unload.
		// we return 0 to ask not to be unloaded - so that user does not have to enter master passphrase repeatedly
		return 0;
		}

	if (loadcalls>1)
		{
		// when multiple loads, we let ourselve exit
//	    // MessageBox(0, "Allowing a multiple DLL unload.", "Mircryption Message", 0);
		// only free mem on the last call
		--loadcalls;
		return 1;
		}

	// MessageBox(0, "Sole DLL unloading!", "Mircryption Message", 0);
	// unload it on exit	
	unloadkeys();
	ircMapClose();
	--loadcalls;
	return 1;
}
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
// Main functions

// Set the global master passphrase to enencrypt the key file
bool setunlockpassphrase(char *passphrase)
	{
	bool bretv;

	// set it
	lstrcpy(masterpassphrase,passphrase);
	// try to unlock it and return true if successful
	bretv=unlock_keys();
	if (!bretv)
		{
		++badtries;
		if (badtries>4)
			badtries=1;
		if (badtries==4)
			{
			MessageBox(0, "You poor bastard.  Have you forgotten your passphrase?  I warned you about this, didn't I?\r\n  I'm going to stop asking you for it.  You can delete the MircryptionKeys.txt file to reset all keys and set a new passphrase.", "Mircryption Message", 0);
			bretv=true;
			}
		else
			MessageBox(0, "Master passphrase does not match that stored in MircryptionKeys.txt file.\r\n  Try again or delete keyfile to erase all keys.", "Mircryption Message", 0);
		}
	return bretv;
	}


// internal func called to return the key associated with a channel
char *lookup_channelkey(char *channelname,char *key,bool wantencrypted)
{
	// lookup the keypass for a channel or return "" if it doesnt exist
	Keypair *keyp=keypairs;
	while (keyp!=NULL)
		{
		if (lstrcmp(keyp->channelname,channelname)==0)
			{
			lstrcpy(key,keyp->key);
			break;
			}
		keyp=keyp->nextp;
		}
	if (keyp==NULL)
		lstrcpy(key,"");
	else if (key[0]!='\0' && passphrasesunlockedflag==false && !wantencrypted)
		lstrcpy(key,"_ENCRYPTED_");
	return key;
}


// load encrypted keys from file
bool load_keys()
{
	// return true on succesfull loading of keys, or if file does not exist
	FILE *fp;
	Keypair *keyp;
	char tempstring[MAXLINELEN+1];
	char *p;
	int len;
	int c;
   	Keypair *lastkeyp;

	// unload any that are already loaded
	unloadkeys();
	
	// load all available keys in encrypted form - open the file
	if ((fp=fopen(KEYFILENAME,"r"))==(FILE *)NULL)
		{
		// this should only happen if file does not exist
		return true;
		}
	
	keypairs=lastkeyp=NULL;
	while (!feof(fp))
		{
		fgets(tempstring,MAXLINELEN,fp);
		if ((tempstring[0]=='/' && tempstring[1]=='/') || tempstring[0]=='\0')
			continue;
		tempstring[MAXLINELEN]='\0';
		len=lstrlen(tempstring)-1;
		while (tempstring[len]==13 || tempstring[len]==10)
			{
			tempstring[len]='\0';
			if (--len<0)
				break;
			}

		p=tempstring;
		for(;;)
			{
			c=*p;
			if (c==' ' || c=='\0') break;
			++p;
			}

		if (*p!='\0')
			{
			++keys;
			*p='\0';
			++p;
			// add a key
			keyp=new Keypair;
			lstrcpy(keyp->channelname,tempstring);
			lstrcpy(keyp->key,p);
			keyp->nextp=NULL;
			if (lastkeyp!=NULL)
				lastkeyp->nextp=keyp;
			else
				keypairs=keyp;
			lastkeyp=keyp;
			}
		}

	fclose(fp);
	passphrasesunlockedflag=false;
	return true;
}


// backup key file
bool backupkeys()
{
	FILE *fp,*fp2;
	char tempstring[MAXLINELEN+1];

/*
	// .bak to .bk2
	wsprintf(tempstring,"%s.bak",KEYFILENAME);
	fp=fopen(tempstring,"r");
	wsprintf(tempstring,"%s.bk2",KEYFILENAME);
	fp2=fopen(tempstring,"w");
	if (fp!=(FILE *)NULL && fp2!=(FILE *)NULL)
		{
		while (!feof(fp))
			{
			fgets(tempstring,MAXLINELEN,fp);
			tempstring[MAXLINELEN]='\0';
			fputs(tempstring,fp2);
			}
		fclose(fp);
		fclose(fp2);
		}
*/

	// file to .bak
	fp=fopen(KEYFILENAME,"r");
	wsprintf(tempstring,"%s.bak",KEYFILENAME);
	fp2=fopen(tempstring,"w");
	if (fp!=(FILE *)NULL && fp2!=(FILE *)NULL)
		{
		while (!feof(fp))
			{
			fgets(tempstring,MAXLINELEN,fp);
			tempstring[MAXLINELEN]='\0';
			fputs(tempstring,fp2);
			}
		fclose(fp);
		fclose(fp2);
		keyfilebackedup=true;
		}
	return keyfilebackedup;
}



// save encrypted keys to file
bool save_keys()
{
	// return true on succesful saving of keys
	FILE *fp;
	Keypair *keyp=keypairs;
   	char* p;

	if (masterpassphrase[0]=='\0' || keys==0 || passphrasesunlockedflag==false)
		return false;

	// and now would be a good time to backup the key file
	if (!keyfilebackedup)
		backupkeys();

	// open the file
	if ((fp=fopen(KEYFILENAME,"w"))==(FILE *)NULL)
		return false;

	// save a header
	fprintf(fp,"// Mircryption Channel Keys - stored in encrypted form (do not forget your master passphrase)\n//\n");
	p=encrypt_string(masterpassphrase,MAGICID);
	fprintf(fp,"MAGICID %s\n",p);
	delete p;	
	// cycle through all keys and save them in encrypted form
	while (keyp!=NULL)
		{
	    if (lstrcmp(keyp->channelname,"MAGICID")!=0)
			    {
			    p=encrypt_string(masterpassphrase,keyp->key);
			    fprintf(fp,"%s %s\n",keyp->channelname,p);
			    delete p;
			    }
		keyp=keyp->nextp;
		}
	fclose(fp);
	return true;
}


// unlock keys in memory
bool unlock_keys()
{
	// return true if keys are unlocked with passphrase
	char key[MAXKEYSIZE];
	char* p;
	
	if (passphrasesunlockedflag==true)
		return true;
	if (masterpassphrase[0]=='\0')
		return false;

	if (keys>0)
		{ 
		// if we have loaded keys which have not been decrypted, we need to test unlock key by checking the magic id
		lookup_channelkey("MAGICID",key,true);
		if (lstrcmp(key,"")==0)
			return false;
		p = decrypt_string(masterpassphrase,key);
		lstrcpy(key,p);
		delete p;
		if (lstrcmp(key,MAGICID)!=0)
			return false;
		// cycle through all keys and unencrypt them
		Keypair *keyp=keypairs;
		while (keyp!=NULL)
			{
			p = decrypt_string(masterpassphrase,keyp->key);
			lstrcpy(keyp->key,p);
			delete p;
			keyp=keyp->nextp;
			}
		}
	
	// set flag to show the passphrases have been unlocked
	passphrasesunlockedflag=true;
	return true;
}


// Callback procedure to receive callbacks from the master key input dialog
BOOL CALLBACK MyDialogProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  char editstring[MAXKEYSIZE];
  switch (msg)
  {
    case WM_INITDIALOG:
		// det the default text
		if (strlen(masterpassphrase)>0)
			SetDlgItemText(hDlg,IDC_PASSWORDEDIT,masterpassphrase);
		return TRUE;
    case WM_COMMAND:
      switch (LOWORD(wParam))
      {
        case IDOK:
			GetDlgItemText(hDlg,IDC_PASSWORDEDIT,editstring,254);
			if (lstrcmp(editstring,"")!=0)
				lstrcpy(masterpassphrase,editstring);
			EndDialog(hDlg, IDOK);
			return TRUE;
		case IDCANCEL:
			EndDialog(hDlg, IDCANCEL);
			return TRUE;
      }
      break;
  }
  return FALSE;
}


// we need the user to give us a valid master passphrase
bool request_unlockpassphrase()
{
	// return true if user gives us a valid passphrase, and unlock the keys, false if not
	bool bretv=false;
	int dialogretv;
	int dialognum;

	// multithread sync - mirc can call this multiple times, and there is no good way to avoid either displaying dialog twice or hanging forever
	// so we will try to avoid the situation of getting here twice from scripts, but if we do, we return from 2nd call as if user hit cancel.
	if (dialogup==true)
		return passphrasesunlockedflag;

	// here we want to ask the user to type in a passphrase in a dialog box
	for (;;)
		{
		dialogup=true;
		// now we use 2 dif. dialogs, depending on whether they are just unlocking it vs. or changing it or initially setting it
		if (passphrasesunlockedflag || keypairs==NULL)
			dialognum=IDD_PASSWORDDIALOG_CHANGE;
		else
			dialognum=IDD_PASSWORDDIALOG;
		dialogretv=DialogBox(DllWindow_hinstance, MAKEINTRESOURCE(dialognum), NULL, (DLGPROC)MyDialogProc);
		if (dialogretv==IDOK && lstrcmp(masterpassphrase,"")!=0)
			{
			// MessageBox(0, masterpassphrase, "passphrase Try", 0);
			// now set master passphrase if appropriate
			bretv=setunlockpassphrase(masterpassphrase);
			if (bretv)
				break;
			else
				{
				// passphrase not accepted
				}
			}
		else
			{
			bretv=false;
			break;
			}
		}
	dialogup=false;
	return bretv;
}


// verify keys are loaded and unlocked.  if keys are locked, try to get user to give passphrase to unlock
bool verify_keysunlocked()
{
	// return true on success
	// first make sure keys are loaded
	bool bretv;

	if (passphrasesunlockedflag)
		return true;
	if (badtries==4)
		{
		// after 4 bad tries at passphrase, we stop asking; this will reset if user explicitly tries to set passphrase
		return false;
		}

	for (;;)
		{
		// now unlock them if need be
		bretv=unlock_keys();
		if (bretv)
			break;
		if (passphrasesunlockedflag)
			break;;
		bretv=request_unlockpassphrase();
		if (!bretv)
			break;
		if (badtries==4)
			break;
		}	
	return passphrasesunlockedflag;
}


// force the keys out of memory
void unloadkeys()
{
	// clear the master passphrase
	masterpassphrase[0]='\0';
	passphrasesunlockedflag=false;
	Keypair *nextp;

	// walk through the linked list and delete all keys
	while (keypairs!=NULL)
		{
		nextp=keypairs->nextp;
		delete keypairs;
		keypairs=nextp;
		}
	keys=0;
	keypairs=NULL;
}

//---------------------------------------------------------------------------



































//---------------------------------------------------------------------------
// Exported DLL script Functions

// %m=$dll(mircryption,mc_encrypt,$chan %om)
MircFunc mc_encrypt (FUNCPARMS)
{
	char key[MAXKEYSIZE];
	char* tmp = data;
	char* channelname = _getlcword(tmp);
	char *text=tmp;
	
	lookup_channelkey(channelname,key,false);
	if (key[0]!='\0')
		{
		if (lstrlen(text)>CRASHLINELEN)
			{
			// text[CRASHLINELEN]='\0';
			wsprintf(data,"%s. Line not sent. Encryption engine cannot encrypt lines more than %d characters.",MIRCRYPTIONERROR,CRASHLINELEN);
			return 3;
			}

		// ok, we got a key for this channel, so encrypt it
		if (verify_keysunlocked())
			{
			if (lstrcmp(key,"_ENCRYPTED_")==0)
				lookup_channelkey(channelname,key,false);	// relook up a prev. encrypted key
			char* p = encrypt_string(key,text);
			wsprintf(data,"%s",p);
			delete p;
			}
		else
			wsprintf(data,"%s master keyfile is not unlocked.",MIRCRYPTIONERROR);
		}
	else
		wsprintf(data,"%s","");

	return 3;
}


//  %m=$dll(mircryption,mc_decrypt,$nick %om)
MircFunc mc_decrypt (FUNCPARMS)
{
	char key[MAXKEYSIZE];
	char* tmp = data;
	char* channelname = _getlcword(tmp);
	char *text=tmp;
	
	lookup_channelkey(channelname,key,false);
	if (key[0]=='\0')
		{
		// we can still decrypt using a disable ecnryption channel
		char tempchannel[MAXCHANNELNAMESIZE+1];
		wsprintf(tempchannel,"-%s",channelname);
		lookup_channelkey(tempchannel,key,false);
		}

	if (key[0]!='\0')
		{
		// ok, we got a key for this channel, so encrypt it
		if (verify_keysunlocked())
			{
			if (lstrcmp(key,"_ENCRYPTED_")==0)
				lookup_channelkey(channelname,key,false);	// relook up a prev. encrypted key
			char* p = decrypt_string(key,text);
			wsprintf(data,"%s",p);
			delete p;
			}
		else
			lstrcpy(data,"key found for channel but text could not be decrypted - make sure master passphrase is set.");
		}
	else
		wsprintf(data,"%s","");		

	return 3;
}


// %m=$dll(mircryption,mc_forceencrypt,$chan %om)
MircFunc mc_forceencrypt (FUNCPARMS)
{
	// same as mc_encrypt, but we encrypt even for disabled channels
	char key[MAXKEYSIZE];
	char* tmp = data;
	char* channelname = _getlcword(tmp);
	char *text=tmp;
	
	lookup_channelkey(channelname,key,false);
	if (key[0]=='\0')
		{
		// we can still decrypt using a disable ecnryption channel
		char tempchannel[MAXCHANNELNAMESIZE+1];
		wsprintf(tempchannel,"-%s",channelname);
		lookup_channelkey(tempchannel,key,false);
		}

	if (key[0]!='\0')
		{
		if (lstrlen(text)>CRASHLINELEN)
			{
			// text[CRASHLINELEN]='\0';
			wsprintf(data,"%s. Line not sent. Encryption engine cannot encrypt lines more than %d characters.",MIRCRYPTIONERROR,CRASHLINELEN);
			return 3;
			}

		// ok, we got a key for this channel, so encrypt it
		if (verify_keysunlocked())
			{
			if (lstrcmp(key,"_ENCRYPTED_")==0)
				lookup_channelkey(channelname,key,false);	// relook up a prev. encrypted key
			char* p = encrypt_string(key,text);
			wsprintf(data,"%s",p);
			delete p;
			}
		else
			wsprintf(data,"%s master keyfile is not unlocked.",MIRCRYPTIONERROR);
		}
	else
		wsprintf(data,"%s","");

	return 3;
}


// $dll(mircryption,mc_setkey,$active %fargs)
MircFunc mc_setkey (FUNCPARMS)
{
	char* tmp = data;
	char* channelname = _getlcword(tmp);
	char* key = tmp;
	char tdata[MAXLINELEN];

	if (!verify_keysunlocked())
		{
		lstrcpy(data,"mircryption keys cannot be set until you set the master passphrase.");
		return 3;
		}

	wsprintf(tdata,"-%s",channelname);
	Keypair *keyp=keypairs;
	while (keyp!=NULL)
		{
		if (lstrcmp(keyp->channelname,channelname)==0 || lstrcmp(keyp->channelname,tdata)==0)
			{
			lstrcpy(keyp->key,key);
			wsprintf(tdata,"mircryption key for %s has been changed to %s.",channelname,key);
			lstrcpy(data,tdata);
			break;
			}
		keyp=keyp->nextp;
		}
	if (keyp==NULL)
		{
		// add the key
		keyp=keypairs;
		keypairs=new Keypair;
		lstrcpy(keypairs->key,key);
		lstrcpy(keypairs->channelname,channelname);
		keypairs->nextp=keyp;
		wsprintf(tdata,"mircryption key '%s' added for channel %s.",key,channelname);
		lstrcpy(data,tdata);
		++keys;
		}

	save_keys();
	return 3;
}


// $dll(mircryption,mc_delkey,$active %fargs)
MircFunc mc_delkey (FUNCPARMS)
{
	char* tmp = data;
	char* channelname = _getlcword(tmp);
	char tdata[MAXLINELEN];
	Keypair **priorp;
	
	priorp=&keypairs;

	wsprintf(tdata,"-%s",channelname);
	// walk through the linked list and print all keys
	Keypair *keyp=keypairs;
	while (keyp!=NULL)
		{
		if (lstrcmp(keyp->channelname,channelname)==0 || lstrcmp(keyp->channelname,tdata)==0)
			{
			wsprintf(tdata,"mircryption key for %s has been deleted (was %s) .",channelname,keyp->key);
			lstrcpy(data,tdata);
			*priorp=keyp->nextp;
			delete keyp;
			--keys;
			save_keys();
			break;
			}
		priorp=&(keyp->nextp);
		keyp=keyp->nextp;
		}
	if (keyp==NULL)
		{
		wsprintf(tdata,"mircryption key for %s was not found.",channelname);
		lstrcpy(data,tdata);
		}

	return 3;
}


// $dll(mircryption,mc_disablekey,$active %fargs)
MircFunc mc_disablekey (FUNCPARMS)
{
	char* tmp = data;
	char* channelname = _getlcword(tmp);
	char tdata[MAXLINELEN];

	wsprintf(tdata,"-%s",channelname);

	// walk through the linked list and print all keys
	Keypair *keyp=keypairs;
	while (keyp!=NULL)
		{
		if (lstrcmp(keyp->channelname,channelname)==0)
			{
			wsprintf(tdata,"mircryption for %s has been temporarily disabled. type /enablekey to re-enable it.",channelname);
			wsprintf(keyp->channelname,"-%s",channelname);
			lstrcpy(data,tdata);
			save_keys();
			break;
			}
		else if (lstrcmp(keyp->channelname,tdata)==0)
			{
			wsprintf(tdata,"mircryption for %s is already disabled.",channelname);
			lstrcpy(data,tdata);
			break;
			}
		keyp=keyp->nextp;
		}
	if (keyp==NULL)
		{
		wsprintf(tdata,"mircryption key for %s was not found.",channelname);
		lstrcpy(data,tdata);
		}

	return 3;
}


// $dll(mircryption,mc_enablekey,$active %fargs)
MircFunc mc_enablekey (FUNCPARMS)
{
	char* tmp = data;
	char* channelname = _getlcword(tmp);
	char tdata[MAXLINELEN];

	wsprintf(tdata,"-%s",channelname);

	// walk through the linked list and print all keys
	Keypair *keyp=keypairs;
	while (keyp!=NULL)
		{
		if (lstrcmp(keyp->channelname,tdata)==0)
			{
			wsprintf(tdata,"mircryption for %s has been re-enabled.",channelname);
			lstrcpy(keyp->channelname,channelname);
			lstrcpy(data,tdata);
			save_keys();
			break;
			}
		else if (lstrcmp(keyp->channelname,channelname)==0)
			{
			wsprintf(tdata,"mircryption for %s is already enabled.",channelname);
			lstrcpy(data,tdata);
			break;
			}
		keyp=keyp->nextp;
		}
	if (keyp==NULL)
		{
		wsprintf(tdata,"mircryption key for %s was not found.",channelname);
		lstrcpy(data,tdata);
		}

	return 3;
}


// $dll(mircryption,mc_displaykey,$active %fargs)
MircFunc mc_displaykey (FUNCPARMS)
{
	char* tmp = data;
	char* channelname = _getlcword(tmp);
	char tdata[MAXLINELEN];

	if (!verify_keysunlocked())
		{
		lstrcpy(data,"not displayable until you set the master passphrase.");
		return 3;
		}

	wsprintf(tdata,"-%s",channelname);

	// walk through the linked list and print all keys
	Keypair *keyp=keypairs;
	while (keyp!=NULL)
		{
		if (lstrcmp(keyp->channelname,tdata)==0 || lstrcmp(keyp->channelname,channelname)==0)
			{
			wsprintf(tdata,"%s",keyp->key);
			lstrcpy(data,tdata);
			break;
			}
		keyp=keyp->nextp;
		}
	if (keyp==NULL)
		lstrcpy(data,"");

	return 3;
}


// $dll(mircryption,mc_listkeys,$active)
MircFunc mc_listkeys (FUNCPARMS)
{
	// we use the sendmirctext function because we may need to display more than max mirc line len (about 900 characters)
	char* tmp = data;

	verify_keysunlocked();		
	if (keys==0)
		{
		wsprintf(data,"no mircryption keys found for any channels.");
		return 3;
		}
	if (lstrcmp(masterpassphrase,"")==0)
		wsprintf(data,"mircryption passphrase is not yet set.  %d Keys:   ",keys);
	else
		wsprintf(data,"mircryption passphrase is '%s'.  %d Keys:   ",masterpassphrase,keys);

	SendMircText ("/statusmsg", data, aWnd, 200,0);
	lstrcpy(data,"");

	// walk through the linked list and print all keys
	Keypair *keyp=keypairs;
	while (keyp!=NULL)
		{
		if (lstrcmp(keyp->channelname,"MAGICID")!=0)
			{
			wsprintf(data,"  %s -> '%s'",keyp->channelname,keyp->key);
			SendMircText ("/statusmsg", data, aWnd, 200,0);
			}
		keyp=keyp->nextp;
		}

	lstrcpy(data,"");
	return 1;
}


// $dll(mircryption,mc_setunlockpassphrase,$active)
MircFunc mc_setunlockpassphrase (FUNCPARMS)
{
	char* tmp = data;
	char* passphrase = tmp;
	bool bretv;

	// set the master passphrase and try to unlock the global file	
	if (lstrcmp(passphrase,"?")==0)
		{
		bretv=request_unlockpassphrase();
		if (!bretv)
			{
			if (passphrasesunlockedflag || keypairs==NULL)
				wsprintf(data,"Change of mircryption master passphrase canceled.");
			else
				wsprintf(data,"Mircryption master passphrase not set.");
			return 3;
			}
		}
	else
		bretv=setunlockpassphrase(passphrase);

	if (bretv)
		{
		if (passphrasesunlockedflag)
			{
			wsprintf(data,"mircryption master passphrase accepted.");
			if (keys>0)
				save_keys();
			}
		}
	else
		wsprintf(data,"mircryption master passphrase rejected.");

	return 3;
}


// $dll(mircryption,mc_forcetopic,$window($chan).hwnd,custom topic text)
MircFunc mc_forcetopic (FUNCPARMS)
{
	// this function is used to force the topic text of a channel to a hardcoded value, used for encrypted topics
	char* tmp = data;
	char topic[MAXLINELEN];
	char *p;
	int count;

	// the handle of the window to change is passed as an ascii number
	HWND window = (HWND)_atolp(_getword(tmp));
	char* preface = _getword(tmp);
	// make sure its a valid handle
	if (IsWindow(window))
		{
		// ok, first get current title of window
		GetWindowText(window,topic,MAXLINELEN-1);
		if (lstrcmp(preface,"yes")==0)
			{
			// add (e) if it dont exit
			if (topic[0]!='(' || topic[1]!='e' && topic[2]!=')' || topic [3]!=' ')
				{
				int len=strlen(topic);
				topic[len+4+1]='\0';
				for (count=len+4;count>=4;--count)
					topic[count]=topic[count-4];
				topic[0]='(';
				topic[1]='e';
				topic[2]=')';
				topic[3]=' ';
				}
			}
		else
			{
			// remove (e) if it exits
			if (topic[0]=='(' && topic[1]=='e' && topic[2]==')' && topic [3]==' ')
				{
				int len=strlen(topic);
				for (count=0;count<=len-4;++count)
					topic[count]=topic[count+4];
				topic[count]=0;
				}
			}

		// now find the first ':' character (where custom topic starts) or eol, and end line there
		p=_mystrchr(topic,':');
		if (p!=NULL)
			{
			*(p+1)='\0';
			// now we ad the custom topic we were passed to it.
			lstrcat(topic," ");
			lstrcat(topic,tmp);
			}
		SetWindowText(window,topic);
		lstrcpy(data,"ok.");
		}
	else
		lstrcpy(data,"error.");
	return 1;
}

// $dll(mircryption,mc_setkeyfile,$fullkeyfilename)
MircFunc mc_setkeyfile (FUNCPARMS)
{
	char* tmp = data;
	char* newfilename = _getword(tmp);
	lstrcpy(KEYFILENAME,newfilename);
	unloadkeys();
	load_keys();
	return 1;
}

// $dll(mircryption,mc_iskeyunlocked,$chan) - returns "yes" if the master keyfile is unlocked
MircFunc mc_iskeyunlocked (FUNCPARMS)
{
	if (passphrasesunlockedflag)
		lstrcpy(data,"yes");
	else
		lstrcpy(data,"no");
	return 3;
}

// $dll(mircryption,mc_isdecrypting,$chan) - returns "yes" if the channel is set to encrypt text (if disabnle say no)
MircFunc mc_isencrypting (FUNCPARMS)
{
	char key[MAXKEYSIZE];
	char* tmp = data;
	char* channelname = _getlcword(tmp);
	char *text=tmp;
	
	lookup_channelkey(channelname,key,false);
	if (key[0]!='\0')
		lstrcpy(data,"yes");
	else
		lstrcpy(data,"no");
	return 3;
}


// $dll(mircryption,mc_isdecrypting,$chan) - returns "yes" if a key exists to decrypt text
MircFunc mc_isdecrypting (FUNCPARMS)
{
	char key[MAXKEYSIZE];
	char* tmp = data;
	char* channelname = _getlcword(tmp);
	char *text=tmp;
	
	lookup_channelkey(channelname,key,false);
	if (key[0]=='\0')
		{
		// we can still decrypt using a disable ecnryption channel
		char tempchannel[MAXCHANNELNAMESIZE+1];
		wsprintf(tempchannel,"-%s",channelname);
		lookup_channelkey(tempchannel,key,false);
		}

	if (key[0]!='\0')
		lstrcpy(data,"yes");
	else
		lstrcpy(data,"no");
	return 3;
}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------

void ircMapOpen()
{
	// open the file map to send messages to irc if its not open alread
	if (ircMapData==NULL)
		{
		ircMapHandle=CreateFileMapping(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,MAXIRCMAPSIZE,"mIRC");
		if (!ircMapHandle) MessageBox(NULL,(char *)"Can't create a file mapping object.",(char *)"Error...",MB_OK);
		ircMapData=(LPSTR)MapViewOfFile(ircMapHandle, FILE_MAP_ALL_ACCESS,0,0,0);
		if (!ircMapData) MessageBox(NULL,(char *)"Can't map view of the file.",(char *)"Error...",MB_OK);
		ircMapTempTextp=new char[MAXTEXTBOXLEN];
	}
}

void ircMapClose()
{
	// close the file map to irc if it is open
	if (ircMapData!=NULL)
		{
		UnmapViewOfFile(ircMapData);
		CloseHandle(ircMapHandle);
		ircMapWindow=0;
		ircMapHandle=0;
		ircMapData=NULL;
		delete ircMapTempTextp;
		ircMapTempTextp=NULL;
	}
}


bool SendMircText (char *preface, char *p, HWND targetwin, int maxlinelen, int speedmod)
{
	// send text to an irc window, breaking it up into line-sized chunks
	char *startp=p;
	int len=0;
	char c;
	int retv;
	bool properstart=false;
	char forcefix=0;
	int sleeptime=MINTEXTSLEEPTIME;
	int textoutcount=0;

	// make sure line length is reasonable
	if (maxlinelen>CRASHLINELEN-1)
		maxlinelen=CRASHLINELEN-1;
	// default to server-safe line length)
	if (maxlinelen<=1)
		maxlinelen=MAXIRCSAFELINELEN;

	// make sure the irc file map is open
	ircMapOpen();

	for (;;++p)
		{
		c=*p;
		if (c==13 || c==10 || (c==0 && len>0))
			{
			*p='\0';
			if (startp==p)
				wsprintf(ircMapData,"%s .",preface);
			else
				wsprintf(ircMapData,"%s %s",preface,startp);
			// now send the text from global file map
			// MessageBox(0, ircMapData, "About to sendmessage", 0);
			retv=SendMessage(targetwin, WM_USER + 200,0,0);
			if (retv==0)
				{
				MessageBox(0, "Error received while trying to send the text to Mirc via SendMessage() api call.", "Mircryption Error", 0);
				break;
				}

			// now sleep for a bit to avoid flood, and inc. sleep time as heuristic to aviod flood detect
			if (speedmod>0)
				{
				Sleep(sleeptime*strlen(startp)*speedmod);
				textoutcount+=strlen(startp);
				if (textoutcount>TEXTSWITCHPOINT)
					{
						if (sleeptime==MINTEXTSLEEPTIME)
							sleeptime=MAXTEXTSLEEPTIME;
					}
				}

			if (forcefix!=0)
				{
				// this happens when we have a line that is too big, so we need to back up and fix last char and go from there
				*p=forcefix;
				forcefix=0;
				--p;
				}
			if (*(p+1)==10)
				++p;
			properstart=false;
			startp=p+1;
			len=0;

			if (c==0)
				break;
			}
		else if (c==0)
			break;
		else if ((c==32 || c==9) && properstart==false)
			{
			// leading spaces convert to .
			*p='.';
			++len;
			properstart=true;
			}
		else
			{
			properstart=true;
			++len;
			}
		if (len>maxlinelen)
			{
			// well we have a problem, we have a line that is too big.
			// so what we want to do now is back up last whitspace and force a linebreak there.
			// failing that (if just pure characters, we will break in the middle
			--len; --p;
			for (;len>0;--len,--p)
				{
				c=*p;
				if (c==32 || c==9)
					{
					// okay we found a whitespace, so we force in a ret, and move pointer back so normal routine will see it on next iteration
					*p=13;
					--p;
					--len;
					break;
					}
				}
			if (len<=0)
				{
				// no whitespace was found, so we are back at the start.  just print out a max length line
				len=maxlinelen-1;
				p=p+len;
				forcefix=*p;
				*p=13;
				--p;
				}
			}
		}
	return true;
}


// Callback procedure to receive callbacks from the master key input dialog
BOOL CALLBACK EditPadDialogProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int bretv;
	char preface[255];

	switch (msg)
		{
		case WM_INITDIALOG:
			return TRUE;
		case WM_COMMAND:
		switch (LOWORD(wParam))
			{
			case IDOK:
				// make sure the irc file map is open
				ircMapOpen();
				GetDlgItemText(hDlg,IDC_RICHEDITTEXT,ircMapTempTextp,MAXTEXTBOXLEN-1);
				EndDialog(hDlg, IDOK);
				wsprintf(preface,"/emsg %s",ircMapChannelname);
				bretv=SendMircText (preface,ircMapTempTextp, ircMapWindow, MAXIRCSAFELINELEN,1);
				return TRUE;
			case IDCANCEL:
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}
		break;
	}
	return FALSE;
}



// bring up a big copy&paste edit box and let them type as much text as they want, then we feed ito to mirc 1 safe short line at a time
// $dll(mircryption,mc_pastepad)
MircFunc mc_pastepad (FUNCPARMS)
{
	// return true if user gives us a valid passphrase, and unlock the keys, false if not
	bool bretv=false;
	int dialogretv;
	char* tmp = data;
	char* cname = _getword(tmp);

	// remember the target window which has called you , which is one of the FUNPARMS
	ircMapWindow=aWnd;
	strcpy(ircMapChannelname,cname);

	// here we want to ask the user to type in a passphrase in a dialog box
	dialogretv=DialogBox(DllWindow_hinstance, MAKEINTRESOURCE(IDD_BIGPAD), NULL, (DLGPROC)EditPadDialogProc);
	return 1;
}


// this is like mc_pastepad, but is for when user already has a long line of text, and just wants to make sure it is of safe size
// $dll(mircryption,mc_splitsay channelname linelen text...)
MircFunc mc_splitsay (FUNCPARMS)
{
	char* tmp = data;
	char* cname = _getword(tmp);
	int linelen=_atolp(_getword(tmp));
	bool bretv;
	char preface[255];
	wsprintf(preface,"/emsg %s",cname);
	bretv=SendMircText (preface, tmp, aWnd, linelen,1);
	return 1;
}

//---------------------------------------------------------------------------


// Callback procedure to receive callbacks from the dialogmenu
BOOL CALLBACK MenuDialogProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int bretv;
	switch (msg)
		{
		case WM_INITDIALOG:
			return TRUE;
		case WM_COMMAND:
		switch (LOWORD(wParam))
			{
			case IDC_BUTN_broadcast:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/mcmeow", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_changemaster:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/keypassphrase", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_color1:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/mcscheme 1", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_color2:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/mcscheme 2", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_disablekey:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/disablekey", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_displaykey:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/displaykey", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_enablekey:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/enablekey", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_help:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/mircryption", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_listkeys:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/listkeys", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_removekey:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/delkey", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_setkey:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/setkey", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_settopic:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/etopic2", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_textpad:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/textpad", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDC_BUTN_agent:
				EndDialog(hDlg, IDOK);
				ircMapOpen();
				bretv=SendMircText ("","/mcspeech", ircMapWindow, MAXIRCSAFELINELEN,0);
				return TRUE;
			case IDCANCEL:
				EndDialog(hDlg, IDCANCEL);
				return TRUE;
			}
		break;
	}
	return FALSE;
}


// bring up a big copy&paste edit box and let them type as much text as they want, then we feed ito to mirc 1 safe short line at a time
// $dll(mircryption,mc_pastepad)
MircFunc mc_menu (FUNCPARMS)
{
	// return true if user gives us a valid passphrase, and unlock the keys, false if not
	bool bretv=false;
	int dialogretv;

	// remember the target window which has called you , which is one of the FUNPARMS
	ircMapWindow=aWnd;

	// here we want to ask the user to type in a passphrase in a dialog box
	dialogretv=DialogBox(DllWindow_hinstance, MAKEINTRESOURCE(IDD_MENUDIALOG), NULL, (DLGPROC)MenuDialogProc);
	return 1;
}

//---------------------------------------------------------------------------
