// Mircryption.h


//---------------------------------------------------------------------------
// To avoid multiple header instantiations
#ifndef _mircryptionh
#define _mircryptionh
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include "mirc_dllshell.h"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#define MIRCDLL_VERSION "3.2"
#define MIRCDLL_INFO "Mircryption DLL"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#define MAXKEYSIZE 255
#define MAXCHANNELNAMESIZE 40
#define MAXLINELEN 1024
#define CRASHLINELEN 650
#define MAXTEXTBOXLEN 63000
#define MAXIRCMAPSIZE 4096

// mirc sadly has linelength limit of about 900.  worse yet, servers often have even smaller limits like 450, so 400 is safe.
// BUT recently we've discovered mirc can choke on words>400 chars, which can result from strings of about 350 chars after blowfishing
#define MAXIRCSAFELINELEN 250
// to test, try small value like 40 or 80
// #define MAXIRCSAFELINELEN 80
// sleep a few ms between line posts to make sure you dont get flood kicked
#define MINTEXTSLEEPTIME 2
#define MAXTEXTSLEEPTIME 20
#define TEXTSWITCHPOINT 1000
// works:2,20,1000

#define MAGICID "MeowMeowMeowskido"
#define MIRCRYPTIONERROR "Mircryption_Error"

struct Keypair
 {
 char key[MAXKEYSIZE];
 char channelname[MAXCHANNELNAMESIZE];
 Keypair *nextp;
};

extern char KEYFILENAME[];
extern char masterpassphrase[];
extern bool passphrasesunlockedflag;
extern char mastercheckword[];
extern Keypair *keypairs;
extern int keys;
extern bool keyfilebackedup;
extern int badtries;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Forward declarations
extern const char *get_mircDllInfo();
extern const char *get_mircDllVersion();
extern int do_mircDllUnload(int mode);
extern bool do_mircDllLoad(LOADINFO* loadinfo);
extern void do_DllStart();
extern bool SendMircText (char *preface, char *p, HWND targetwin, int maxlinelen, int speedmod);
//
extern char *lookup_channelkey(char *channelname,char *keypass,bool wantencrypted);
extern bool load_keys();
extern void unloadkeys();
extern bool unlock_keys();
extern void ircMapClose();
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
#endif