; ------------------------------------------------------------------------
; mircryption - v3.2 - mirc script for encryption/decryption
; 1/12/02, Dark Raichu
;-------------------------------------------------------------------------
; See the mircryption help file for complete installation and usage info.
; ------------------------------------------------------------------------



; ------------------------------------------------------------------------
; installer, called once on first installation.
; just checks for the proper version of mirc
on 1:LOAD: {
  if ( $version < 5.9 ) {
    echo 4 -s $nopath($script) cannot be installed - it requires mIRC version 5.9 or later!
    echo
    mc_uninstall silent
    halt
  }
  echo 4 -si2 Mircryption script is now installed.  Use right-click pop-ups to access Mircryption menu.
  echo 4 -si2 You can uninstall this script from the main menubar: Commands->Mircryption->Uninstall.
}
; ------------------------------------------------------------------------

; ------------------------------------------------------------------------
; initialization startup each time you launch mirc
on 1:START: {
  ; version
  %mc_scriptversion = 3.2

  ; let user know the script is loaded  
  echo 4 -s Mircryption version %mc_scriptversion (dll v $+ $dll( mircryption , version, dummy ) $+ ) started.

  ; set variables to defaults if they are not already set
  /setmcvariables
  ; set current color/identification scheme (defaults to [] around encrypted nicks)
  /mcscheme
  ; set timers to make sure encrypted-state of window captions are shown properly
  /setmctimers
}
; ------------------------------------------------------------------------







; ------------------------------------------------------------------------
; help
alias mircryption {
  ; launch the help file if it is in mirc directory
  if ( $exists(mircryption.chm) ) .run mircryption.chm
  else if ( $exists(mircryption.hlp) ) .run mircryption.hlp
  ; now show commandline help in status window
  echo 4 -si4 - 
  echo 4 -si4 . NOTE: For full help use the mirc menu:  Help->Help Files->mircryption
  echo 4 -si4 .   
  echo 4 -si4 . Mircryption version %mc_scriptversion - Dark Raichu - 1/1/02
  echo 4 -si2 .  some dll code borrowed from tabo (www.aircscript.com); blowfish encryption algorithms are by bruce schneier and jim conger.
  echo 4 -si4 . 
  echo 4 -si2 . Use right-click popup menus to access all mircryption commands, or from command line:
  echo 4 -si6 .... /setkey [channel] [keyphrase]'   enables encryption/decryption on specified channel (defaults to current channel), using key specified.  can be used to add or modify keys.
  echo 4 -si6 .... /delkey [channel]'               removes encryption key for specified channel (defaults to current channel).
  echo 4 -si6 .... /disablekey'                     temporarily disables encryption for current channel
  echo 4 -si6 .... /enablekey'                      re-enables encryption for current channel
  echo 4 -si6 .... /displaykey'                     shows you (and only you) the key for the current channel
  echo 4 -si6 .... /plain ...'                      send ... text without encryption
  echo 4 -si6 .... /listkeys'                       lists all channel encryption keys currently stored
  echo 4 -si6 .... /keypassphrase [keyword]'          set or change current master keyfile passphrase to keyword
  echo 4 -si6 .... /mcscheme X'                     set color/identification scheme, where X is the number 1 or 2
  echo 4 -si6 .... /etopic [text]'                  set an encrypted topic for the channel.
  echo 4 -si6 .... /encryptecho channelname text'   echoes encrypted version of text IF channel is set to encrypt, otherwise plaintext
  echo 4 -si6 .... /decryptecho channelname text'   echoes decrypted version of text IF channel has a key, otherwise plaintext
  echo 4 -si6 .... /setkeyfile filename'            set the name of the file to be used for storing/retrieving keys
  echo 4 -si6 .... /emsg channelname test...        replacement for /msg - encrypts text if appropriate (good for bots, etc.)
  echo 4 -si6 .... /mcmeow [channelname]            broadcast handshake query to channel
  echo 4 -si6 .... /etext text...                   same as typing text... in encrypted channel, BUT igores disabling, and wont send to channel without encryption
  echo 4 -si6 .... /textpad                         launches the textpad dialog for copy and paste of big text
  echo 4 -si6 .... /mcspeech                        toggle ms agent speech
  echo 4 -si4 . 
  echo 4 -si2 . See mircryption help file (Help Menu->Help Files) for more information and troublshooting help.
  echo 4 -si2 . You can uninstall this script from the main menubar: Commands->Mircryption->Uninstall.
  echo 4 -si2 - 
}
; ------------------------------------------------------------------------















; ---------------------------------------------------------------------------
; Custom Right-click Popup Menus

menu menubar,status {
  &Mircryption
  .list all stored channel encryption keys:/listkeys
  .set/change master keyfile passphrase:/keypassphrase
  .&Broadcast meow handshake to all channels:/mcmeowall
  .-
  .select color/identification scheme &1:/mcscheme 1
  .select color/identification scheme &2:/mcscheme 2
  .&MS Agent Speech Toggle :.mcspeech
  .-
  .Uninstall the mircryption script now:/mc_uninstall
  .-
  .cleanup all encrypted topics:/mcfixalltopics
  .help/about:/mircryption
}

menu channel {
  &Mircryption
  .set an encrypted &Topic for current channel:/etopic2
  .&Launch the textpad for large text copy and paste:/textpad
  .display &Keyphrase for current channel:/displaykey
  .&Broadcast meow handshake to channel:/mcmeow
  .-
  .&Set encryption key for current channel:/setkey
  .remove encryption key from current channel:/delkey
  .-
  .&Disable current channel encryption temporarily:/disablekey
  .re-&Enable current channel encryption:/enablekey
  .-
  .list all stored channel encryption keys:/listkeys
  .set/change master keyfile passphrase:/keypassphrase
  .-
  .select color/identification scheme &1:/mcscheme 1
  .select color/identification scheme &2:/mcscheme 2
  .-
  .&MS Agent Speech Toggle :.mcspeech
  .-
  .help/about:/mircryption
}

menu query {
  &Mircryption
  .&Launch the textpad for large text copy and paste:/textpad
  .display &Keyphrase for current channel:/displaykey
  .&Broadcast meow handshake to channel:/mcmeow
  .-
  .&Set encryption keyphrase for current channel:/setkey
  .remove encryption key from current channel:/delkey
  .-
  .&Disable current channel encryption temporarily:/disablekey
  .re-&Enable current channel encryption:/enablekey
  .-
  .list all stored channel encryption keys:/listkeys
  .set/change master keyfile passphrase:/keypassphrase
  .-
  .select color/identification scheme &1:/mcscheme 1
  .select color/identification scheme &2:/mcscheme 2
  .-
  .&MS Agent Speech Toggle :.mcspeech
  .-
  .help/about:/mircryption
}


; our custom dll menu which we can trigger programmatically or alias to a FN key
alias mcmenu {
  /dll mircryption mc_menu
}
; ---------------------------------------------------------------------------







; ------------------------------------------------------------------------------------------------------
; Events for incoming text

; incoming - incoming from channel
on ^*:text:*:#: {
  ; process it - and get back a 1 if we handled it, so should haltdef, or 0 if not and should return normally
  ; echo in incoming text#, nick is $nick chan is $chan  active is $active
  if ($mc_oneinput( $nick , $chan , text , $1 , $2-) == 1) haltdef
}

; incoming - incoming from query window
on ^*:text:*:?: {
  ; process it - and get back a 1 if we handled it, so should haltdef, or 0 if not and should return normally
  ; echo in incoming text?, nick is $nick chan is $chan  active is $active
  if ($mc_oneinput( $nick , $nick , query , $1 , $2-) == 1) haltdef
} 

; incoming - incoming action from channel
on ^*:action:*:#: {
  ; process it - and get back a 1 if we handled it, so should haltdef, or 0 if not and should return normally
  if ($mc_oneinput($nick, $chan , action , $1 , $2-) == 1) haltdef
}

; incoming - incoming action from query window
on ^*:action:*:?: {
  ; process it - and get back a 1 if we handled it, so should haltdef, or 0 if not and should return normally
  if ($mc_oneinput( $nick , $nick , queryaction , $1 , $2-) == 1) haltdef
}

; incoming - incoming from dcc chat
on ^*:chat:*: {
  ; process it - and get back a 1 if we handled it, so should haltdef, or 0 if not and should return normally
  ; echo in incoming chat, nick is $nick chan is $chan  active is $active
  if ($mc_oneinput( $nick , $chan , query , $1 , $2-) == 1) haltdef
}

; incoming - incoming from notice - seems to be overridden by earlier text
on ^*:notice:*:*: {
  ; process it - and get back a 1 if we handled it, so should haltdef, or 0 if not and should return normally
  if ($mc_oneinput( $nick , $nick , query , $1 , $2-) == 1) haltdef
}


; here is the new single procedure for echoing all incoming text/actions
; $1 is speaker (usually $nick), $2 is output target ($chan or $nick) , $3 is type of echo (text or action), $4 is first word (mcps if encrypted), $5- is the encrypted text (with mcps prefix removed)
alias mc_oneinput {
  var %om 
  if ( ($4 == mcps) || ($4 == [B]mcps)) {
    var %firstword | %firstword = $gettok( $5 , 1 , 32)
    if (%firstword == meow) {
      ; special handshake protocol
      .mchandshake $gettok($5 , 2- , 32)
      return 1
    } 
    %om = $5-
    var %pre
    var %plen
    var %m | %m = %om
    var %mout
    var %ename | %ename = $2
    var %encryptename

    if ( [ $left(%ename,4) ] == chat && $mid(%ename,5,1) == $chr(32)) {
      ; echo in chat
      var %elen = $len(%ename)
      %elen = %elen - 5
      %encryptename = $right(%ename , %elen)
      %ename = $chr(61) $+ %encryptename
    }
    else %encryptename = %ename

    ; decrypt text if appropriate using dll
    %m = $dll( mircryption , mc_decrypt , %encryptename %om)
    if ( (%m != %om) && (%m != $null) ) {
      ;echo text to proper target channel/querywindow
      if ($3 == action) %pre = %mc_preaction_decrypt $1
      else %pre = %mc_prenick_decrypt $+ $1 $+ %mc_postnick_decrypt
      %mout = %pre %m
      if ($highlight( %mout )) %mout = $strip(%mout)
      if (%mc_indent == nick) %plen = $len($strip($pre)) + 1
      else %plen = %mc_indent
      .echo -lbmfti $+ %plen  %ename %mout
      ; we add a haltdef here (not sure it will do anything), so that if error on msagent we will still bypass normal oninput handling
      haltdef
      ; at this point we have: decrypted text (%m), target channel/querywindow ($2), and speaker ($1)
      ; if you had your own stuff you wanted to do to incoming text, you would do it to %m here
      ; built-in mirc msagent (text-to-speech) support does not work with mircryption, as it tries to read encrypted text, so we need to do a work-around
      .mc_msagent $1 %encryptename $3 %m
      ; return saying we have handed it
      return 1
    }
  }
  else {
    if ($5 == $null) %om = $4
    else %om = $4-
  }

  ; if we get here, it means we did not "handle" it, and %om is the text
  ; new option to take over from mirc speaking\
  if (%mc_agent_replacemirc == yes) .mc_msagent $1 %encryptename $3 %om
  ; IF we wanted to handle normal incoming text as well, we could do it here and return 1  
  return 0
}
; ------------------------------------------------------------------------------------------------------





; ------------------------------------------------------------------------------------------------------
; Processing functions for outgoing text


on *:input:*: {
  ; outgoing - outgoing to channel
  var %om | %om = $1-
  var %m | %m = %om
  var %ename | %ename = $chan
  var %encryptename

  ;  echo $active channel $chan window outgoing event active is $active

  if ($1 == /me || ($1 == -me)) {
    %om = $2-
    %m = %om
  }
  else if ($1 == /msg) {
    %om = $3-
    %m = %om
    %ename = $2
  }
  else if ($1 == /etopic) {
    /etopic2 $2-
    halt
    if ($2 == $null) %om = $?="set encrypted topic for $chan to:"
    else %om = $2-
    %m = %om
  }
  else if ( $left($1,1) == / ) return

  if ( [ $left(%ename,4) ] == chat && $mid(%ename,5,1) == $chr(32)) {
    var %elen = $len(%ename)
    %elen = %elen - 5
    %encryptename = $right(%ename , %elen)
    %ename = $chr(61) $+ %encryptename
  }
  else %encryptename = %ename

  ; some servers kill text bigger than about 400 characters.  FURTHERMORE it appears mirc can choke on words>400 characters.
  ; which can happen after we encrypt a line with spaces (spaces can dissapear)
  ; if we detect that the user is trying to send such a big message, we will try to break it up for them
  if ($len(%m) > 250) {
    .dll mircryption mc_splitsay %encryptename 250 %m
    haltdef
    return
  }

  ; the single characyer reverser.  if the text starts with %mc_reversechar then we reverse whatever mode we are in, if encrypotion enabled, then we dont, if not, we do
  if ($left($1,1) == %mc_reversechar ) {
    var %tlen | %tlen = $len($1-) - 1
    if ($dll(mircryption,mc_isencrypting , %encryptename) == yes) /plain $right($1- , %tlen)
    else /etext $right($1- , %tlen)
    haltdef
    return
  }

  ; encrypt message if appropriate
  %m = $dll( mircryption , mc_encrypt , %encryptename %om)

  if ( $left(%m,17) == Mircryption_Error) {
    ; error encrypting output
    .echo 4 -t %m
  }
  else if (%m != %om && %m != $null) {
    ; output encrypted message (note that this does not echo the message to users window)
    ; echo user's original text to the user, with indicator letting user know if it was encrypted
    if ($1 == /me || ($1 == -me)) {
      .action mcps %m
      var %pre | %pre = %mc_preaction_encrypt $me 
      .echo $prespopt2(%pre)  $+ $colour(own text) $+ %pre %om
      if (%mc_agent_char_mynick != disable) /mc_msagent $me $active action %om
    }
    else if ($1 == /msg) {
      .msg $2 mcps %m
      var %pre | %pre = %mc_prenick_encrypt $+ -> $+ %mc_postnick_encrypt $2
      .echo $prespopt2(%pre)  $+ $colour(own text) $+ %pre %om
      if (%mc_agent_char_mynick != disable) /mc_msagent $me $active text %om
    }
    else {
      .msg %ename mcps %m
      var %pre | %pre = %mc_prenick_encrypt $+ $me $+ %mc_postnick_encrypt
      .echo $prespopt2(%pre)  $+ $colour(own text) $+ %pre %om
      if (%mc_agent_char_mynick != disable) /mc_msagent $me $active text %om
    }
  }
  else {
    ; normal text not encrypted
    if ($1 == /me && %mc_agent_char_mynick != disable && %mc_agent_replacemirc == yes) /mc_msagent $me $active action %om
    else if ($1 == /msg && %mc_agent_char_mynick != disable && %mc_agent_replacemirc == yes) /mc_msagent $me $active text %om
    else if (%mc_agent_char_mynick != disable && %mc_agent_replacemirc == yes) /mc_msagent $me $active text %om
    return
  }
  haltdef
}


alias prespopt2 {
  ; helper functions for nice indenting
  var %plen
  if (%mc_indent == nick) %plen = $len($strip($1)) + 1
  else %plen = %mc_indent
  return -tni $+ %plen
}
; ------------------------------------------------------------------------------------------------------






; ------------------------------------------------------------------------
; text formatting stuff

alias mcscheme {
  ; set color/indent scheme presets
  ; allow the user to select from multiple colouring/identification schemes (1 or 2)

  if ( $1 != $null ) {
    %mc_scheme = $1
    echo -s mircryption using color/identification scheme $1
  }
  if ( %mc_scheme == $null ) %mc_scheme = 1

  ; colors - these are shorthands used in indicator customization below - they default to current irc settings.
  ;          customize to your pleasure, but keep in mind that if you use hardcoded numbers, things may look
  ;          wierd if you change your mirc color scheme.  this command is called on startup or you can call it
  ;          if you change mirc colors while mirc is running.

  %mc_defaulttext_color = $colour(normal text)
  ;%mc_dulltext_color = $colour(grayed text)
  %mc_dulltext_color = $colour(notice text)
  %mc_action_color = $colour(action text)
  %mc_info_color = $colour(info text)

  if ( %mc_scheme == 1 ) {
    ; SCHEME 1 uses brackets around text that is encrypted or decrypted, and + for encrypted/decrypted actions
    ;  very unobtrusive but may be easier to forget if you are encrypted or no
    %mc_prenick_encrypt = [
    %mc_postnick_encrypt = ]
    %mc_prenick_decrypt = [
    %mc_postnick_decrypt = ]
    %mc_preaction_encrypt =  $+ %mc_action_color $+ +
    %mc_preaction_decrypt =  $+ %mc_action_color $+ +
    %mc_pretopic = (e) 
  }
  else {
    ; SCHEME 2 prepends a gray e or d to indicate whether text is encrypted or decryted
    %mc_prenick_encrypt =  $+ %mc_dulltext_color $+ e $+  $+ $colour(own text) $+ <
    %mc_postnick_encrypt = >
    %mc_prenick_decrypt =  $+ %mc_dulltext_color $+ d $+  $+ %mc_defaulttext_color $+ <
    %mc_postnick_decrypt = >
    %mc_preaction_encrypt =  $+ %mc_dulltext_color $+ e $+  $+ $colour(own text) $+ *
    %mc_preaction_decrypt =  $+ %mc_dulltext_color $+ d $+  $+ %mc_action_color $+ *
  %mc_pretopic = (e) }
}
;---------------------------------------------------------------------------





; ------------------------------------------------------------------------------------------------------
; For encrypted topics - we hve to be clever and do kludges.  basically what we do is use a dll to
;  change the windo titlebar for a channel, even though mirc thinks the topic is something else
;  becasue of this, we must constantly be on watch for things that could make mirc reset the channel
;  window title, and rechange it back (after a tiny delay).

on ^*:TOPIC:*: {
  ; incoming - incoming action from channel
  ; do nothing if the preface is missing - we will encrypt this if channel is set to encrypt
  ; main thing this does is decrypt incoming encrypted topics
  ; but we also now try to fix up topics that should be encrypted but arent like doublte-click topic
  ; changes unfortunately, when you double click mirc always immediately sends out the new topic and
  ; i cant stop it or encrypt it before it sends it out so no way to stop people in channel without
  ; encryption from seeing it for that you have to use /etopic or /etopic menu.  best i can do is
  ; re-encrypt it after it goes out for later people.  HOWEVER, i think its better to give a warning
  ; in this case.

  ;  echo nick is $nick and me is $me

  ; otherwise, if user tries to set a plain topic on encrypted (through double click box for example), then we force it to encrypt
  if ( ($1 != mcps) && ($1 != [B]mcps) ) {
    if ($nick == $me && $dll(mircryption,mc_isencrypting , $chan) == yes) {
      ;  re-encrypt it
      ;      .haltdef
      ;      /etopic2 $1-
      ; instead of re-encrypting it, which gives false sense of security, we will do the opposie
      if (%mc_warnings == yes) echo 4 -i2 $chan Warning - you have set a plain text topic in an encrypted channel.  Use /etopic or right-click menu to set encrypted topics.
    }
    if ((%mc_agent_replacemirc == yes) && ($nick != $me)) /mc_msagent $nick $chan topic $1-
    return
  }

  if ($len( $1- ) > 901 ) return;
  var %om | %om = $2-
  var %m | %m = %om
  ;echo $chan channel window incoming text event

  ; decrypt text if appropriate using dll
  %m = $dll( mircryption , mc_decrypt , $chan %om)

  ;copy decrypted text to channel
  if (%m != %om && %m != $null) {
    %m = %mc_pretopic %m
    %m = $strip(%m)
    /dll mircryption mc_forcetopic $window($chan).hwnd $dll(mircryption,mc_isencrypting , $chan) %m
    %mc_lasttopic_author = $nick
    %mc_lasttopic_time = $asctime(ddd mmm d h:nn:ss)
    .echo $colour(topic text) -i2 $chan *** %mc_lasttopic_time %mc_lasttopic_author encrypts topic to ' $+ %m $+ '
    if (%mc_lasttopic_author != $me) /mc_msagent %mc_lasttopic_author $chan topic %m
    .haltdef
  }
  ; else /dll mircryption mc_forcetopic $window($chan).hwnd $dll(mircryption,mc_isencrypting , $chan) %om
}


; we neet to capture join to update encrypted topics
on *:JOIN:#: {
  ; we need to use 1 second timers to insure that the window is updated before we fix the topic
  ; name the timer based on channel so many can work simultaneously
  ; note we also pass the nick of the person joining - this is so our fixer reports the new topic if we ourselves join the channel

  ; dummy encyrpt, to force requesting of master passphrase when joining encrypted channels right away
  var %dummy =  $dll( mircryption , mc_encrypt , $chan dummytext)
  if ($nick == $me) {
    /mcfixtopic $chan speak
    .timerMCFIXTOPIC $+ $chan 1 1 mcfixtopic $eval($chan) speak
  }
  else {
    /mcfixtopic $chan $nick
    .timerMCFIXTOPIC $+ $chan 1 1 mcfixtopic $eval($chan) $eval($nick)
  }
  if (%mc_agent_replacemirc == yes && %mc_agent_speakevents == yes && $nick != $me) /mc_msagent $nick $chan join dummytext
}

on *:PART:#: {
  if ($dll(mircryption , mc_iskeyunlocked , $chan) == yes) /mcfixtopic_smart $chan
  if (%mc_agent_replacemirc == yes && %mc_agent_speakevents == yes && $nick != $me) /mc_msagent $nick $chan part dummytext
}

on *:QUIT: {
  if ($dll(mircryption , mc_iskeyunlocked , $chan) == yes) /mcfixalltopics
  if (%mc_agent_replacemirc == yes && %mc_agent_speakevents == yes && $nick != $me) /mc_msagent $nick dummy quit dummytext
}

on *:KICK:#: {
  if ($dll(mircryption , mc_iskeyunlocked , $chan) == yes) /mcfixtopic_smart $chan
  if (%mc_agent_replacemirc == yes && %mc_agent_speakevents == yes) /mc_msagent dummy dummy other $knick was kicked from $chan by $nick
}

on *:CONNECT: {
  if (%mc_agent_replacemirc == yes && %mc_agent_speakevents == yes) /mc_msagent dummy dummy other Connected to server $server with nickname $nick
}

on *:DISCONNECT: {
  if (%mc_agent_replacemirc == yes && %mc_agent_speakevents == yes) /mc_msagent dummy dummy other Disconnected from server $server
}

on *:NOTIFY: {
  if (%mc_agent_replacemirc == yes && %mc_agent_speakevents == yes) /mc_msagent dummy dummy other NOTICE: $nick has connected to irc
}

on *:NOTIFY: {
  if (%mc_agent_replacemirc == yes && %mc_agent_speakevents == yes) /mc_msagent dummy dummy other NOTICE: $nick has disconnected from irc
}


; private $nick events.
on *:OPEN:?:*: if ($dll(mircryption , mc_iskeyunlocked , $nick) == yes) .mcfixtopic_smart $nick else  var %dummy =  $dll( mircryption , mc_encrypt , $nickn dummytext)
on *:OPEN:=: if ($dll(mircryption , mc_iskeyunlocked , $nick) == yes) .mcfixtopic_smart = $+ $nick else  var %dummy =  $dll( mircryption , mc_encrypt , $nick dummytext)

; channel $chan events.
on *:MODE:*: if ($dll(mircryption , mc_iskeyunlocked , $chan) == yes) .mcfixtopic_smart $chan
on *:SERVERMODE:*: if ($dll(mircryption , mc_iskeyunlocked , $chan) == yes) .mcfixtopic_smart $chan

; believed not imp
;raw 323:*: /mcfixtopic_smart | echo PLS. Check encrypted toics and INFORM DARK RAICHU -> raw 323 $1 , $2
;raw 329:*: /mcfixtopic_smart | echo PLS. Check encrypted toics and INFORM DARK RAICHU -> raw 329 $1 , $2
;raw 4:*: /mcfixtopic_smart | echo PLS. Check encrypted toics and INFORM DARK RAICHU -> raw 4 $1 , $2
;raw 331:*: /mcfixtopic_smart | echo PLS. Check encrypted toics and INFORM DARK RAICHU -> raw 331 $1 , $2
;raw 374:*: /mcfixtopic_smart | echo PLS. Check encrypted toics and INFORM DARK RAICHU -> raw 374 $1 , $2
;raw 7:*: /mcfixtopic_smart | echo PLS. Check encrypted toics and INFORM DARK RAICHU -> raw 7 $1 , $2

;raw 366:*: if ($dll(mircryption , mc_iskeyunlocked, $2) == yes) .mcfixtopic_smart $2


; save last topic change details - this is nesc. since topic does not pass speaker
raw 333:*: {
  %mc_lasttopic_author = $3
  %mc_lasttopic_time = $asctime($4,ddd mmm d h:nn:ss)
}
; ------------------------------------------------------------------------------------------------------



; ------------------------------------------------------------------------------------------------------
; topic fixups


alias mcfixtopic_smart {
  ; change topic fix and a delayed one as well to make sure mirc finished with its own update first
  var %cname

  if ($1 == $null) %cname = $chan
  else %cname = $1
  .mcfixtopic $eval(%cname)
  .timerMCFIXTOPIC $+ $cname 1 1 mcfixtopic $eval($cname)
}

alias mcfixalltopics {
  ; here we need to go through ALL windows and fix up their titlebars
  ; this can happen if user suddenly enters a valid masterpass after failing to in begining,
  ; or other mirc events that redraw all windows without individually triggering events on individual channels
  var %querycount | %querycount = $query(0)
  var %chatcount | %chatcount = $chat(0)
  var %ccount = 1
  while ($chan(%ccount) != $null) {
    /mcfixtopic_smart $chan(%ccount)
    inc %ccount
  }
  %ccount = 1
  while (%ccount <= %chatcount) {
    /mcfixtopic_smart = $+ $chat(%ccount)
    inc %ccount
  }
  %ccount = 1
  while (%ccount <= %querycount) {
    /mcfixtopic_smart $query(%ccount)
    inc %ccount
  }
}

alias mcfixalltopics2 {
  ; here we need to go through ALL windows and fix up their titlebars, but not a delayed version (can be used manually)
  ; this can happen if user suddenly enters a valid masterpass after failing to in begining,
  ; or other mirc events that redraw all windows without individually triggering events on individual channels
  var %ccount | %ccount = 1
  var %ctotal | %ctotal= $chan(0)
  while (%ccount <= %ctotal) {
    /mcfixtopic $chan(%ccount)
    inc %ccount
  }
  %ccount = 1
  while (%ccount <= %chatcount) {
    /mcfixtopic = $+ $chat(%ccount)
    inc %ccount
  }
  %ccount = 1
  while (%ccount <= %querycount) {
    /mcfixtopic $query(%ccount)
    inc %ccount
  }
}

; decrypt an encrypted topic
alias mcfixtopic {
  var %m
  var %cname
  if ($1 == $null) %cname = $chan
  else %cname = $1
  var %ename

  if (%cname == $null) return
  %ename = $chatchan(%cname)
  ; echo fixing up channel name is %cname ename is %ename

  %m = $chan(%cname).topic
  var %mf
  ; %mf = $token(1, 32, %m) - cant get this to work for some reason
  var %pos | %pos = $pos(%m , $chr(32))
  var %remlen | %remlen = $len(%m) - %pos
  %mf = $left(%m , %pos)
  var %mn | %mn = $right(%m , %remlen)

  ;  echo fixing topic for channel %cname is %m and %mn

  if ( (%mf == mcps) || (%mf == [B]mcps )) {
    %m = $dll( mircryption , mc_decrypt , %ename %mn)
    ;copy decrypted text to channel
    if (%m != %mn && %m != $null) {
      %m = %mc_pretopic %m
      %m = $strip(%m)
      /dll mircryption mc_forcetopic $window(%cname).hwnd $dll(mircryption,mc_isencrypting , %ename) %m
      if ($2 == speak) .echo $colour(topic text) -i2 %cname *** Topic decrypted as ' $+ %m $+ '
    }
    else /dll mircryption mc_forcetopic $window(%cname).hwnd $dll(mircryption,mc_isencrypting , %ename) %mn
  }
  else {
    ; echo blank for %cname, m is %m encrypting is [ $dll(mircryption,mc_isencrypting , %ename) ]
    /dll mircryption mc_forcetopic $window(%cname).hwnd $dll(mircryption,mc_isencrypting , %ename) %m
  }
}
; ------------------------------------------------------------------------------------------------------



; ------------------------------------------------------------------------------------------------------
; a watcher function - for updating window titlebars if a new window is opened
;  this is nescesary because mirc is braindead when it comes to some events
;  and there appears to be no way to trigger an event if you yourself open
;  a query window, for example

alias mc_windowchangewatch {
  var %curwincount | %curwincount = $chan(0)
  var %querycount | %querycount = $query(0)
  var %chatcount | %chatcount = $chat(0)
  var %ccount

  if ( %curwincount > %mc_curwincount) {
    %ccount = 1
    while (%ccount <= %curwincount) {
      /mcfixtopic $chan(%ccount)
      inc %ccount
    }
  }
  %mc_curwincount = %curwincount

  if ( %querycount > %mc_querycount ) {
    %ccount = 1
    while (%ccount <= %querycount) {
      /mcfixtopic $query(%ccount)
      inc %ccount
    }
  }
  %mc_querycount = %querycount

  if ( %chatcount > %mc_chatcount ) {
    %ccount = 1
    while (%ccount <= %chatcount) {
      /mcfixtopic = $+ $chat(%ccount)
      inc %ccount
    }
  }
  %mc_chatcount = %chatcount
}
; ---------------------------------------------------------------------------








; ------------------------------------------------------------------------------------------------------
; Accessory channel functions

alias chatchan {
  ; chat channels have '=' in front of their names, we remove that
  var %cname = $1
  if ($left(%cname , 1) == $chr(61)) {
    ; chat channel names have = in front, we remove that
    var %clen = $len(%cname)
    dec %clen
    %cname = $right(%cname , %clen)
  }
  else if ( [ $left(%cname,4) ] == chat && $mid(%cname,5,1) == $chr(32)) {
    var %clen = $len(%cname)
    %clen = %clen - 5
    %cname = $right(%cname , %clen)
  }

  return %cname
}


; set (add or modify) keys.
;  "/setkey [channelname] passkeyphrase"  (if channelname not specified, current channel is used)
alias setkey {
  var %cname
  var %kname
  if ($1 == $null) {
    %cname = $active
  }
  else if ($2 == $null) {
    %cname = $1
  }
  else {
    %cname = $1
    %kname = $2-
  }
  var %wname = %cname
  %cname = $chatchan(%cname)

  if (%cname == Status Window) {
    echo 4 -s You cannot encrypt the status window. Em.. Why would you want to do that anyway?
    return
  }

  if (%kname == $null) {
    var %prevkey = $dll( mircryption , mc_displaykey , %cname)
    if (%prevkey != $null) %kname = $input(Use words and symbols (20-50 characters):,1,Set new keyphrase for channel %cname,%prevkey)
    else %kname = $input(Use words and symbols (20-50 characters):,1,Set new keyphrase for channel %cname)
    if (%kname == $null) return
  }

  echo 4 -s $dll( mircryption , mc_setkey , %cname %kname)
  /mcfixtopic_smart %wname
}

; addkey is same as setkey
alias addkey /setkey $1-


; delete key(s)
;  "/delkey [channelname]"  (if channelname not specified, current channel is used)
alias delkey {
  var %cname | %cname = $active
  if ($1 != $null) %cname = $1
  var %wname = %cname
  %cname = $chatchan(%cname)

  echo 4 -s $dll(mircryption, mc_delkey, %cname)
  /mcfixtopic_smart %wname
}


; temporarily disable a key
alias disablekey {
  var %cname | %cname = $active
  if ($1 != $null) %cname = $1
  var %wname = %cname
  %cname = $chatchan(%cname)
  echo 4 -s $dll( mircryption , mc_disablekey , %cname)
  mcfixtopic_smart %wname
}


; re-enable a temporarily disabled key
alias enablekey {
  var %cname | %cname = $active
  if ($1 != $null) %cname = $1
  var %wname = %cname
  %cname = $chatchan(%cname)
  echo 4 -s $dll( mircryption , mc_enablekey , %cname)
  mcfixtopic_smart %wname
}


; display current key to the user
alias displaykey {
  var %cname | %cname = $active
  if ($1 != $null) %cname = $1
  %cname = $chatchan(%cname)
  var %keyval | %keyval = $dll( mircryption , mc_displaykey , %cname)
  if (%keyval == $null) echo mircryption key for %cname has not been set.
  else echo 4 -s mircryption key for %cname is ' $+ %keyval $+ '
}


; etopic activated through menu
alias etopic2 {
  ; silly test to see if user is encrypting on this channel
  var %ename | %ename = $chan
  var %test1 | %test1 = test text
  var %test2 | %test2 = $dll( mircryption , mc_encrypt , %ename %test1)
  if (%test2 == %test1 || %test2 == $null) {
    .echo 4 -t Encrypted topic cannot be set - you are not set to encrypt on this channel.
    return
  }

  var %om
  if ($1 == $null) {
    var %prevtopic | %prevtopic = $chan(%ename).topic
    var %pos | %pos = $pos(%prevtopic , $chr(32))
    if (%pos > 0) {
      var %remlen | %remlen = $len(%prevtopic) - %pos
      var %mf | %mf = $left(%prevtopic , %pos)
      var %mn | %mn = $right(%m , %remlen)
      if ( (%mf == mcps) || (%mf == [B]mcps )) {
        %prevtopic = $right(%prevtopic , %remlen)
        %prevtopic = $dll( mircryption , mc_decrypt , %ename %prevtopic)
        if (%prevtopic == $null) %prevtopic = $chan(%ename).topic
      }
    }
    if (%prevtopic == $null) %om = $input($chan $+ :,1,Mircryption Encrypted Topic)
    else %om = $input($chan $+ :,1,Mircryption Encrypted Topic,%prevtopic)
    if (%om == $null) return
  }
  else %om = $1-
  var %m | %m = %om

  ; encrypt message if appropriate
  %m = $dll( mircryption , mc_encrypt , %ename %om)

  if ( $left(%m,17) == Mircryption_Error) {
    ; error encrypting output
    .echo 4 -t %m
  }
  .topic %ename mcps %m
  ; we need to manually remember that we are the author of the last topic change, since raw 333 is not triggered on self topic change
  %mc_lasttopic_author = $me
  %mc_lasttopic_time = $asctime(ddd mmm d h:nn:ss)
}
;---------------------------------------------------------------------------




;---------------------------------------------------------------------------
; Accesory keyfile functions

; set master passowrd for key file
;  "/keypassphrase passphrase"
alias keypassphrase {
  var %kname | %kname = $1-

  if (%kname == $null) %kname = ?
  echo 4 -s $dll(mircryption, mc_setunlockpassphrase, %kname)
  /mcfixalltopics
}

;; dont let user pass unless they enter the correct passphrase
alias mc_requirepassphrase {
  while ( $dll(mircryption , mc_iskeyunlocked, dummy) != yes) {
    echo 4 -s $dll(mircryption, mc_setunlockpassphrase, ?)
  }
  /mcfixalltopics
}

; display a list of keys
;  "/listkeys" (lists all stored keys)
alias listkeys {
  .dll mircryption mc_listkeys , $active
}


; set the name of the file to be used for storing/retrieving keys
alias setkeyfile {
  /dll mircryption mc_setkeyfile $1
  echo -s Mircryption using keyfile $1 $+ .
}
;---------------------------------------------------------------------------





; ---------------------------------------------------------------------------
; Accessory output functions

; for bots&other scripts, aux. func to return encrypted or decrypted txt, as appropriate
; /mc_encrypt $channelname text...
alias mc_encrypt {
  var %m | %m = $dll( mircryption , mc_encrypt , $1 $2-)
  if (%m == $null) return $2-
  return %m
}

; for bots&other scripts, aux. func to return encrypted or decrypted txt, as appropriate
; /mc_decrypt $channelname text...
alias mc_decrypt {
  var %m | %m = $dll( mircryption , mc_decrypt , $1 $2-)
  if (%m == $null) return $2-
  return %m
}


alias decryptecho .echo $mc_decrypt($1-)
alias encryptecho .echo $mc_encrypt($1-)


; for bots&other scripts, aux. func to display encrypted or decrypted txt, as appropriate
alias emsg {
  var %m | %m = $dll( mircryption , mc_encrypt , $1 $2-)
  if ((%m == $null) || (%m == $2-)) msg $1 $2-
  else {
    .msg $1 mcps %m
    var %pre | %pre = %mc_prenick_encrypt $+ $me $+ %mc_postnick_encrypt
    .echo $prespopt2(%pre) $1  $+ $colour(own text) $+ %pre $2-
  }
}


; for bots&other scripts, aux. func to display encrypted or decrypted txt, as appropriate, to *default chan*
alias esay {
  var %cname | %cname = $chan
  if (%cname == $null) %cname = $active
  %cname = $chatchan(%cname)
  var %m | %m = $dll( mircryption , mc_encrypt , %cname $1-)
  if ((%m == $null) || (%m == $1-)) /msg %cname $1-
  else {
    .msg %cname mcps %m
    var %pre | %pre = %mc_prenick_encrypt $+ $me $+ %mc_postnick_encrypt
    .echo $prespopt2(%pre)  $+ $colour(own text) $+ %pre $1-
  }
}


; plaintext command will bypass encryption   /plain text...  
alias plain { say $1- }
alias plaintext { say $1- }


; forced encryption, even id channel disabled, and warning if no key exists for channel
alias etext {
  var %cname | %cname = $chan
  if (%cname == $null) %cname = $active
  %cname = $chatchan(%cname)
  var %m | %m = $dll( mircryption , mc_forceencrypt , %cname $1-)
  if (%m == $null) .echo 4 Encrypted text could not be sent, since no key is defined for this channel.
  else {
    .msg %cname mcps %m
    var %pre | %pre = %mc_prenick_encrypt $+ $me $+ %mc_postnick_encrypt
    .echo $prespopt2(%pre)  $+ $colour(own text) $+ %pre $1-
  }
}


; used when dll needs to send text to status window
alias statusmsg {
  .echo 4 -si2  $1-
}
;---------------------------------------------------------------------------









;---------------------------------------------------------------------------
; Meow handshake routines - 
;   sends message of form   mcps meow codeword {encrypted meow}
;   reply will be from all people using mircryption on the channel, an
;   *unencryped* reply.  to code #1
;    mcmeow-> $nick (encrypting/decrypting) [(keyphrase [mis]match)]
; send request for users to report
alias mcmeow {
  var %cname
  if ($1 != $null) %cname = $1
  else %cname = $active
  if (%cname == Status) {
    .mcmeowall
    return
  }
  %cname = $chatchan(%cname)

  .msg %cname mcps meow meow $me %mc_scriptversion $dll( mircryption , mc_forceencrypt , %cname meow)
  .echo -ti2 %cname broadcasting meow to %cname $+ ...
}

alias mcmeowall {
  var %curwincount | %curwincount = $chan(0)
  var %querycount | %querycount = $query(0)
  var %chatcount | %chatcount = $chat(0)
  var %ccount

  %ccount = 1
  while (%ccount <= %curwincount) {
    /mcmeow $chan(%ccount)
    inc %ccount
  }
  %ccount = 1
  while (%ccount <= %querycount) {
    /mcmeow $query(%ccount)
    inc %ccount
  }
  %ccount = 1
  while (%ccount <= %chatcount) {
    /mcmeow $chat(%ccount)
    inc %ccount
  }
}


alias mchandshake {
  ; we have received a handshake request - so answer it ($1 is codeword)

  if ($1 == meow) {
    ; standard meow type harmless handshake request - user wants to know if we are encrypting/decrypting/ have same keyphrase or no
    ; $2 is requester, $3 is optional an encrypted word of meow
    var %encstatus
    var %cname | %cname = $chan
    var %replyto | %replyto = $chan
    if (%cname == $null) {
      %cname = $nick
      %replyto = $me
    }

    var %ecs1 | %ecs1 = $dll(mircryption, mc_isencrypting , %cname)
    var %ecs2 | %ecs2 = $dll(mircryption, mc_isdecrypting , %cname)
    if ( (%ecs1 == yes ) && (%ecs2 == yes) ) %encstatus = crypting
    else if (%ecs2 == yes) %encstatus = decrypting only
    else %encstatus = no encryption for this channel

    var %keystatus
    if (%encstatus != no encryption for this channel) {
      %ecs1 = $dll( mircryption,mc_decrypt,%cname $4)
      if (%ecs1 == meow) %encstatus = %encstatus (key match) %mc_meowtag_match
      else %encstatus = %encstatus (key mismatch) %mc_meowtag_mismatch
    }
    else %encstatus = %encstatus %mc_meowtag

    ; send reply
    ./msg %cname mcps meow meowreply $2 %replyto $chr(91) $+ %mc_scriptversion $+ $chr(93) $me -> %encstatus
    .echo -sti2 [=^.^=] [ $3 ] $2 -> $1 %cname
  }

  if ($1 == meowreply) {
    ; show the reply we have received, if it is in answer to a question we asked
    if ($me == $2) {
      .echo -ti2 $3 [=^.^=] $4-
    }
  }
}


; helper func to help you set your meow reply taglines
alias setmeowtaglines {
  var %tnewtag
  if (%mc_meowtag != $null) %tnewtag = $input(Tagline for replies to default meow broadcasts:,1,Meow Broadcast Reply Tagline,%mc_meowtag)
  else %tnewtag = $input(Tagline for replies to default meow broadcasts:,1,Meow Broadcast Reply Tagline)
  if (%tnewtag != $null) %mc_meowtag = %tnewtag

  if (%mc_meowtag_mismatch != $null) %tnewtag = $input(Tagline for replies to key-mismatch meow broadcasts:,1,Meow Broadcast Reply Tagline,%mc_meowtag_mismatch)
  else %tnewtag = $input(Tagline for replies to key-mismatch meow broadcasts:,1,Meow Broadcast Reply Tagline)
  if (%tnewtag != $null) %mc_meowtag_mismatch = %tnewtag

  if (%mc_meowtag_match != $null) %tnewtag = $input(Tagline for replies to key-match meow broadcasts:,1,Meow Broadcast Reply Tagline,%mc_meowtag_match)
  else %tnewtag = $input(Tagline for replies to key-match meow broadcasts:,1,Meow Broadcast Reply Tagline)
  if (%tnewtag != $null) %mc_meowtag_match = %tnewtag
}

;---------------------------------------------------------------------------



;---------------------------------------------------------------------------
; we provide a huge (63k) edit box for copy and paste of big text which gets fed to mirc one slow line at a time to
;  avoid line limits and flood killing.  Note this calls \emsg to process lines.
; you would probably want to put this on a function-key shortcut
alias textpad {
  /dll mircryption mc_pastepad $active
}
;---------------------------------------------------------------------------



;---------------------------------------------------------------------------
; MS Agent replacement speech elements, part 1

alias mc_msagent {
  ; main agent speaking procedure
  ; $1 is speaker, $2 is channel they speaking in, $3 is text type (text,action,topic,part,quit,join,other) $4- is text they said. use $3==other to just speak the $4- text
  var %agentname
  var %agentid
  var %agentfile
  var %tosay
  var %toact
  var %endpos
  var %slen
  var %speaker | %speaker = $1

  ; are they disabling all ms agent features
  if (%mc_agent_enable == no) return

  if (%speaker == $me) %speaker = mynick

  ; First check if there is a specific agent assigned for this speaker+channel, if so, use it
  %agentname = mc_agent_char_ $+ %speaker $+ $2
  %agentfile = [ % ] $+ %agentname
  %agentfile = $eval( [ %agentfile ] )
  if (%agentfile == $null) {
    ; First check if there is a specific agent assigned for this speaker, if so, use it
    %agentname = mc_agent_char_ $+ %speaker
    %agentfile = [ % ] $+ %agentname
    %agentfile = $eval( [ %agentfile ] )
    if (%agentfile == $null) {
      ; Else check if there is a specific agent assigned to this channel, if so, use it
      %agentname = mc_agent_char_ $+ $2
      %agentfile = [ % ] $+ %agentname
      %agentfile = $eval( [ %agentfile ] )
      if ((%agentfile == $null) && (($3 == query) || ($3 == queryaction))) {
        ; If not, if there's a generic one set for all queries, use that one
        %agentname = mc_agent_char_query
        %agentfile = [ % ] $+ %agentname
        %agentfile = $eval( [ %agentfile ] )
      }
      if (%agentfile == $null) {
        ; If not, if there's a default character use that one
        %agentname = mc_agent_char_default
        %agentfile = [ % ] $+ %agentname
        %agentfile = $eval( [ %agentfile ] )
      }
    }
  }

  ; they can disable speech for any channel by using disable as the agent file name
  if ((%agentfile == disable) || (%agentfile == $null)) return
  ; temporary disable
  if ($left(%agentfile , 1) == - ) return

  ; we mow use agent file as agent name, so that we dont try to open multiple copies of same agent file
  %agentid = %agentfile

  if ($agent( %agentid ).fname == $null) {
    ; A kuldge to load the agent if it is not loaded - fname is blank if agent is not loaded
    .gload %agentid %agentfile
    var %agentopts | %agentopts = %mc_agent_options
    var %opt1
    var %opt2
    while (%agentopts != $null) {
      %opt1 = $gettok(%agentopts , 1 , 32)
      %opt2 = $gettok(%agentopts , 2 , 32)
      ; echo trying msagent option %opt1 %agentid %opt2
      .gopts %opt1 %agentid %opt2
      %agentopts = $deltok(%agentopts , 1-2 , 32)
    }
    if (%mc_agent_size != $null) /gsize %agentid %mc_agent_size
    if (%mc_agent_move != $null) /gmove %agentid %mc_agent_move
  }

  ; Decide what to say based on form of speech
  if ($3 == topic ) %tosay = $1 changes $2 topic to $4-
  else if ($3 == join ) %tosay = $1 has joined $2
  else if ($3 == part ) %tosay = $1 has left $2
  else if ($3 == quit ) %tosay = $1 quits irc
  else if (($3 == action) || ($3 == queryaction)) {
    if ($right($4- , 1) == $chr(93)) {
      ; user can end an action with a [ACTION] to force an action
      %endpos = $pos($4- , $chr(91))
      if (%endpos >= 1) {
        %endpos = %endpos + 1
        %slen = $len($4-) - %endpos
        %toact = $mid($4- , %endpos, %slen )
        %slen = %endpos - 2
        %tosay = $1 $left($4- , %slen)
      }
    }
    if (%toact == $null) {
      %tosay = $1 $4-
      if (%mc_agent_actionanimations == yes) %toact = $smartanimations(%agentfile , $4-)
    }
    ; update the last speaker
    set %mc_agent_lastspeaker_ [ $+ [ $eval(%agentfile) ] ] $1
  }
  else if (($3 == query) || ($3 == channel) || ($3 == text)) {
    ; now we do a new trick, the variable %mc_agent_smartnames == yes, means that we dont repeat the "[nick] says: " part if the same agent is speaking for same person again
    if (%mc_agent_speechanimations == yes) %toact = $smartanimations(%agentfile , $4-)
    if (%mc_agent_smartnames == yes) {
      var %agentspeakervar
      var %agentlastspeaker
      %agentspeakervar = [ % ] $+ mc_agent_lastspeaker_ $+ %agentfile
      %agentlastspeaker = $eval( [ %agentspeakervar ] )
      ; echo -s Last speaker for agent %agentfile was contents of var %agentspeakervar which is %agentlastspeaker
      if (%agentlastspeaker == $1) %tosay = $4-
      else {
        %tosay = $1 says: $4-
        set %mc_agent_lastspeaker_ [ $+ [ $eval(%agentfile) ] ] $1
      }
    }
    else %tosay = $1 says: $4-
  }
  else if ($3 == other ) %tosay = $4-
  else {
    ; unkown situation
    %tosay = $1 $4-
  }

  ; now say it
  %tosay = $replace(%tosay , $chr(124) , $chr(46) )
  %tosay = $lower(%tosay)
  if (%tosay != $null && %tosay != $1) {
    ; first stop any current animations (otherwise they queue up and can get slow).  might be nice to stop all characters animations?
    .gstop %agentid play
    ;and now run the current one
    .gtalk %mc_agent_talkoptions %agentid %tosay
  }

  ; movement?
  if ($4 == moves && %mc_agent_agentscanmove == yes ) {
    if (%tosay == $1 moves left) {
      var %delta = $agent(%agentid).w
      var %x = $agent(%agentid).x + %delta
      var %y = $agent(%agentid).y
      .gmove %agentid %x %y 1
      %toact = $null
    }
    else if (%tosay == $1 moves right) {
      var %delta = $agent(%agentid).w
      var %x = $agent(%agentid).x - %delta
      var %y = $agent(%agentid).y
      .gmove %agentid %x %y 1
      %toact = $null
    }
    else if (%tosay == $1 moves up) {
      var %delta = $agent(%agentid).h
      var %x = $agent(%agentid).x
      var %y = $agent(%agentid).y - %delta
      .gmove %agentid %x %y 1
      %toact = $null
    }
    else if (%tosay == $1 moves down) {
      var %delta = $agent(%agentid).h
      var %x = $agent(%agentid).x
      var %y = $agent(%agentid).y + %delta
      .gmove %agentid %x %y 1
      %toact = $null
    }              
  }

  ; play animations
  if (%toact != none && %toact != $null) {
    ; echo animation %toact engaged.
    .gplay %agentid %toact
  }
}


on *:AGENT: {
  ; provide an option to unload or hide agents after they speak
  if (%mc_agent_enable == no) return
  if (%mc_agent_afterspeech == unload) .gunload $agentname
  else if (%mc_agent_afterspeech == hide) .ghide $agentname
}


alias mcspeech {
  ; enable, disable, or toggle ms agent speech functions
  if (($1 == $null) && (%mc_agent_enable == no)) %mc_agent_enable = yes
  else if (($1 == $null) && (%mc_agent_enable == yes)) %mc_agent_enable = no
  else if (($1 == on) || ($1 == yes)) %mc_agent_enable = yes
  else if (($1 == off) || ($1 == no)) %mc_agent_enable = no
  if (%mc_agent_enable == yes) {
    echo -s Mircryption MS Agent speech functions now enabled.
    /mc_msagent dummy dummy other Mircryption speech functions now enabled.   
  }
  else {
    echo -s Mircryption MS Agent speech functions now disabled.
    var %varval , %agentfile
    var %vcount | %vcount = $var(%mc_agent_char_*,0)
    var %hashtable
    var %tempvar
    while (%vcount > 0) {
      %varval = $var(%mc_agent_char_* , %vcount)
      %agentfile = $eval( [ %varval ] )
      if ($pos( %agentfile , .acs ) > 1) {
        if ($agent( %agentfile ).fname != $null) .gunload %agentfile
        %hashtable = $replace(%agentfile , .acs , .aal)
        %tempvar = $hget(%hashtable)
        if (%tempvar != $null) {
          ; free the hash table for the agent - note that this isnt really nesc. to stop speech, but saves memory
          /hfree %hashtable
        }
      }
      %vcount = %vcount - 1
    }
  }
}
;---------------------------------------------------------------------------



;---------------------------------------------------------------------------
; MS Agent replacement speech elements, part 2 - fun animations

alias smartanimations {
  ; examine the text and pick some animaitons to play based on text content.  $1 is agentid,  $2- is action sentence
  ; return 'none' if no animations
  var %anims
  var %hashtable
  var %tempvar
  var %eadded

  ; first repace all punctuation with spaces  
  var %sentence | %sentence = $2-
  %sentence = $replace( %sentence , $chr(44), $chr(32))
  %sentence = $replace( %sentence , $chr(45), $chr(32))
  %sentence = $replace( %sentence , $chr(46), $chr(32))
  %sentence = $replace( %sentence , $chr(63), [ $chr(32) $+ _q_ $+ $chr(32) ] )
  %sentence = $replace( %sentence , $chr(33), [ $chr(32) $+ _e_ $+ $chr(32) ] )
  %sentence = _ $+ $chr(32) $+ %sentence $+ $chr(32) $+ _

  ; if we dont already have a hashtable for this character, load or create
  %hashtable = $replace($1 , .acs , .aal)
  %tempvar = $hget(%hashtable)
  if (%tempvar == $null) {
    if ($exists(msagentdefault.aal) || $exists(%hashtable)) {
      ; has table not yet built, so make it
      .hmake [ %hashtable ] 100
      %eadded = %eadded + [ $addhashanimfile($1 , %hashtable , msagentdefault.aal) ]
      %eadded = %eadded + [ $addhashanimfile($1 , %hashtable , %hashtable) ]
      if (%eadded == 0) /hfree %hashtable
      else %tempvar = %hashtable
    }
  }
  if (%tempvar == $null) return none

  ; echo -s hashtable %hashtable loaded

  ; now we walk through it, searching for regex matches of keys, and adding animations if we get a hit

  var %total = $hget(%hashtable,0).item , %x = 0
  var %i , %ii , %data , %dataword
  var %totalpat
  ; echo -s total hashtable lenth is %total
  while (%total > 0) {
    %ii = $hget(%hashtable , %total).item
    %i = $gettok(%ii , 1 , 32)
    %data = $hget(%hashtable , %total).data
    if (%data == $null) %data = $hget(%hashtable , %ii)
    ; %data is comma separated patterns, we want to check for a match of any
    %totalpat = $numtok(%data , 44)
    ; echo -s animation %i , data is %data , and pats is %totalpat
    while (%totalpat > 0) {
      %dataword = $gettok(%data , %totalpat , 44)
      ; echo -s checking if pattern %dataword matches string
      if (%dataword iswm %sentence) {
        ; yes we got a match
        %anims = %anims %i
        ; echo -s got a match on %i with data %data
        /break
      }
      dec %totalpat
    }
    dec %total
  }

  ; echo smartanimations for agent $1 is %anims and string was %sentence
  ; now return a single animation if only one qualifies, or pick a random one from the list
  if (%anims == $null) return none
  var %animcount | %animcount = $numtok(%anims,32)
  if (%animcount > 1) {
    %animcount = $rand(1 , %animcount)
    %anims = $gettok(%anims , %animcount , 32)
  }

  return %anims
}


alias addhashanimfile {
  ; add a file into hash table
  ; $1 is agent id , $2 is hashtablename , $3 is file name
  var %hashtable = $2
  var %agentid = $1
  var %eadded

  if ($exists($3) == $false) return 0

  ; make a temp hash table and load defaults into it
  .hmake temphash 200
  .hload temphash $3

  ; now walk through our animtions, and pick off the ones from this file that we support
  var %acount , %count
  var %aname
  var %dindex
  var %dval

  %acount = $agent($1 , 0).anim
  %count = 1
  %acount = $agent(%agentid , 0).anim
  while (%count <= %acount) {
    %aname = $agent(%agentid , %count).anim
    %dindex = $hfind(temphash , %aname , 1)
    ; echo -s testing anim %count is %aname dindex is %dindex
    if (%dindex != $null) {
      ; echo -s got a match on default %aname
      %dval = $hget(temphash , %dindex)
      .hadd %hashtable %aname %dval
      inc %eadded
    }
    inc %count
  }

  ; echo -s Mircryption msagent support addeded %eadded animation actions to $1 from $3

  ; free the default table
  /hfree temphash
  return %eadded
}


alias isvalidanimation {
  ; is the animation a valid one to play exists for the agent
  ; $1 is agentid , $2 is animation to play
  ; return $2 if it is a vlid animaiton, or none if not
  var %acount
  var %aname
  %acount = $agent($1 , 0).anim

  ; echo -s In isavlid with $1 and $2 and %acount
  while (%acount > 0) {
    %aname = $agent($1 , %acount).anim
    ;echo -s checking against animation %acount which is %aname
    if (%aname == $2) return $2
    dec %acount
  }
  return none
}


; helper function to create a .aal file listing animations for an agent, useful if you want to make your own custom .aal file for an agent
alias makeanimlistfile {
  ; $1 is agent file name including .acs
  var %agentid = $1
  var %acount
  var %aname
  var %count = 1

  if ($pos(%agentid , $chr(46)) == $null ) %agentid = %agentid $+ .acs

  var %filename = $replace(%agentid , .acs , .aal)
  ; echo -s Checking filename %filename
  if ($exists(%filename) && $2 != overwrite ) {
    echo -s File %filenme already exists, it will not be overwritten.  Use  /makeanimlistfile <agentname> overwrite'  to foce overwrite
    return
  }

  if ($agent( %agentid ).fname == $null) {
    ; A kuldge to load the agent if it is not loaded - fname is blank if agent is not loaded
    .gload %agentid %agentid
  }

  write -c %filename
  %acount = $agent(%agentid , 0).anim
  while (%count <= %acount) {
    %aname = $agent(%agentid , %count).anim
    echo Writing animation %count which is %aname
    write %filename %aname
    write %filename %aname
    inc %count
  }
}



alias msagent_rescue {
  ; bring an agent back on screen. $1 is agent
  var %agentid | %agentid = $1
  if ($pos(%agentid , $chr(46)) == $null ) %agentid = %agentid $+ .acs
  .gmove %agentid 100 100 1
}

alias msagent_rollcall /msagent_rolecall $1-

alias msagent_rolecall {
  ; line up agents

  var %varval , %agentfile
  var %vcount | %vcount = $var(%mc_agent_char_*,0)
  var %hashtable
  var %tempvar
  var %x | %x = 5
  var %y | %y = 100
  var %ox , %oy
  var %movedyet
  var %delta
  var %justification

  if ($1 == v) %justification = v
  else %justification = h

  .hmake temphash 20

  %vcount = $var(%mc_agent_char_*,0)
  if (%justification == h) {
    %ox = 60
    %oy = 170
  }
  else {
    %ox = 80
    %oy = 80
  }
  %x = %ox
  %y = %oy
  while (%vcount > 0) {
    %varval = $var(%mc_agent_char_* , %vcount)
    %agentfile = $eval( [ %varval ] )
    if ($pos( %agentfile , .acs ) > 1) {
      if ($agent( %agentfile ).fname != $null) {
        ; ok, go
        if (%justification == h) {
          %delta = $agent(%agentfile).h
          %delta = %delta / 2
          %y = %oy - %delta
        }
        else {
          %delta = $agent(%agentfile).w
          %delta = %delta / 2
          %x = %ox - %delta
        }
        %movedyet = $hfind(temphash , [ %agentfile ] , 1)
        if (%movedyet == $null) {
          .gmove %agentfile %x %y 1
          if (%justification == h) {
            %delta = $agent(%agentfile).w
            %delta = %delta / 1.5
            %x = %x + %delta
          }
          else {
            %delta = $agent(%agentfile).h
            %delta = %delta
            %y = %y + %delta
          }
          .hadd temphash [ %agentfile ] yes
        }
      }
    }
    %vcount = %vcount - 1
  }
  .hfree temphash
}

;---------------------------------------------------------------------------






;--------------------------------------------------------------------------- 
; some startup and uninstall helper funcs

alias setmcvariables {
  ; default persistant variables - if they are blank they will be set here. after that you can set
  ;  them programmaticaly in a script OR in the alt-R variables section, and they will preserver
  ;  even if you install a new version.

  ; keyfile name
  if (%mc_keyfile == $null) %mc_keyfile = MircryptionKeys.txt
  ; meow reply tags for fun in different situations
  ; if (%mc_meowtag = $null) %mc_meowtag = [keke]
  ; if (%mc_meowtag_match = $null) %mc_meowtag_match = [keke]
  ; if (%mc_meowtag_mismatch = $null) %mc_meowtag_mismatch = [keke]
  if (%mc_hotkey == $null) %mc_hotkey = /sF12

  ; modify this (default is set to shift-f12) for your quick mircryption menu
  ; note you always have the right-click menus - this is for you lazy bastards
  alias %mc_hotkey /mcmenu

  ; set name of key file - without a full path this defaults to mirc directory
  ; but you can use a full explicit directory if you have multiple mircs that want to share a single keyfile.
  /dll mircryption mc_setkeyfile %mc_keyfile

  ; If the variable %mc_keypassphrase exists, we try to unlock keyfile with it, so user does not have to enter it when mirc starts.
  ; VERY IMPORTANT!!! -> This is a big security risk - it means that if someone gains access to the files on your computer,
  ;  they can use your keyfile and thus decrypt all traffic on all your channels.  Use only if you are sure your machine is
  ;  secure.  We recommend you instead enter the passphrase manually once per irc session.
  if (%mc_keypassphrase != $null) /keypassphrase %mc_keypassphrase

  ; the following line checks the variable %mc_requirespass.  if it is set to yes, then no user can run mirc without
  ;  immediately entering the master passphrase.  note that this can be bypassed if the modify this script, and
  ;  is provided for minimal tamper protection, and to make mircryption ask passphrase on load, instead of default
  ;  ask on first time encryption/decryption is required for a channel.
  if (%mc_requirespass == yes) /mc_requirepassphrase
  else %mc_requirespass = no

  ; indendation modes - use a number for indentation amount (2 is mirc default, 11 lines up after max nick size, nick means left-align under current nick (default) )
  if (%mc_indent == $null) %mc_indent = nick

  ; user can set which character at begining of line means reverse encryption (i like ' but am told its too easy to hit accidentally)
  if (%mc_reversechar == $null) %mc_reversechar = `

  ; some ms agent speech default variables - create and set to defaults if they dont exist
  if (%mc_agent_enable == $null) %mc_agent_enable = no
  if (%mc_agent_afterspeech == $null) %mc_agent_afterspeech = nothing
  if (%mc_agent_options == $null) %mc_agent_options = -e off -h off
  if (%mc_agent_talkoptions == $null) %mc_agent_talkoptions = -lu
  if (%mc_agent_speakevents == $null) %mc_agent_speakevents = yes
  if (%mc_agent_actionanimations == $null) %mc_agent_actionanimations = yes
  if (%mc_agent_speechanimations == $null) %mc_agent_speechanimations = yes
  if (%mc_agent_replacemirc == $null) %mc_agent_replacemirc = yes
  if (%mc_agent_smartnames == $null) %mc_agent_smartnames = yes
  if (%mc_agent_agentscanmove == $null) %mc_agent_agentscanmove = yes
  if (%mc_warnings == $null) %mc_warnings = yes
  if (%mc_agent_char_default == $null) %mc_agent_char_default = merlin.acs
  if (%mc_agent_char_mynick == $null) %mc_agent_char_mynick = disable
}


alias setmctimers {  
  ; set window watcher timer - for fixing up captions of windows as they change from encrypted status to not
  ;  really annoying that we have to do it this way, but is a useful features
  %mc_curwincount = 0
  %mc_chatcount = 0
  %mc_querycount = 0
  ; every 2 seconds do a quick check for new query windows to fixup
  .timermcWindowWatcher 0  2 /mc_windowchangewatch
  ; every 10 seconds refresh captions of all windows no matter what
  .timermcWindowWatcher2 0  10 /mcfixalltopics
}


; uninstall helper
alias mc_uninstall {
  ; uninstall script
  ; stop all timers
  .timermcWindowWatcher off
  .timermcWindowWatcher2 off
  ; erase all permanent variables related to script

  if ($1 != silent) {
    ; verify they really want to install it
    var %confirmer
    %confirmer = $input(Type the word 'uninstall' to confirm uninstallation:,1,Uninstall Mircryption)
    if (%confirmer != uninstall) {
      echo 4 -s Uninstallation of mircryption canceled.
      return
    }
  }
  unset %mc_*
  echo 4 -s Mircryption script $nopath($script) has been uninstalled.
  echo 4 -s To reinstall, type /load -rs mircryption.mrc
  .unload -rs mircryption.mrc
  .unload -rs $script
  halt
}
;--------------------------------------------------------------------------- 
